#include <config.h>
/* widget.c generated by valac 0.56.3, the Vala compiler
 * generated from widget.vala, do not modify */

/* tarot implements the rules of the tarot game*/
/* Copyright (C) 2019, 2024  Vivien Kraus*/
/**/
/* This program is free software: you can redistribute it and/or modify*/
/* it under the terms of the GNU General Public License as published by*/
/* the Free Software Foundation, version 3 of the License.*/
/**/
/* This program is distributed in the hope that it will be useful, but*/
/* WITHOUT ANY WARRANTY; without even the implied warranty of*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU*/
/* General Public License for more details.*/
/**/
/* You should have received a copy of the GNU General Public License*/
/* along with this program.  If not, see <http://www.gnu.org/licenses/>.*/

#include "tarot_app.h"
#include <gtk/gtk.h>
#include <glib.h>
#include "tarot-gobject.h"
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <stdio.h>

enum  {
	TAROT_WIDGET_0_PROPERTY,
	TAROT_WIDGET_GAME_PROPERTY,
	TAROT_WIDGET_NUM_PROPERTIES
};
static GParamSpec* tarot_widget_properties[TAROT_WIDGET_NUM_PROPERTIES];
#define __vala_TarotGame_free0(var) ((var == NULL) ? NULL : (var = (_vala_TarotGame_free (var), NULL)))
#define __vala_TarotGameEvent_free0(var) ((var == NULL) ? NULL : (var = (_vala_TarotGameEvent_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	TAROT_WIDGET_SELECT_BID_SIGNAL,
	TAROT_WIDGET_SELECT_DECLARATION_SIGNAL,
	TAROT_WIDGET_SELECT_CALL_SIGNAL,
	TAROT_WIDGET_SELECT_DISCARD_SIGNAL,
	TAROT_WIDGET_SELECT_HANDFUL_SIGNAL,
	TAROT_WIDGET_SELECT_CARD_SIGNAL,
	TAROT_WIDGET_NUM_SIGNALS
};
static guint tarot_widget_signals[TAROT_WIDGET_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _TarotWidgetPrivate {
	TarotTrickCardView* trick_widget;
	TarotCenterCardView* center_widget;
	TarotFanCardView* hand_widget;
	GtkStack* entry_stack;
	GtkFlowBox* widget_bid;
	GtkButton* button_take;
	GtkButton* button_push;
	GtkButton* button_straight_keep;
	GtkButton* button_double_keep;
	GtkLabel* player_information_myself;
	GtkBox* widget_decl;
	GtkButton* button_slam;
	GtkBox* widget_call;
	TarotCardSelection* call_selection;
	GtkButton* button_call;
	GtkBox* widget_discard;
	TarotCardSelection* discard_selection;
	GtkButton* button_discard;
	GtkBox* widget_handful;
	TarotCardSelection* handful_selection;
	GtkButton* button_handful;
	gboolean allow_play;
	TarotGame* current_game;
	GtkTreeView* player_information_others;
	GtkLabel* call_info;
};

static gint TarotWidget_private_offset;
static gpointer tarot_widget_parent_class = NULL;

static void _vala_TarotGame_free (TarotGame* self);
static void tarot_widget_select_pass (TarotWidget* self);
static void _tarot_widget_select_pass_gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self);
static void tarot_widget_select_take (TarotWidget* self);
static void _tarot_widget_select_take_gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self);
static void tarot_widget_select_push (TarotWidget* self);
static void _tarot_widget_select_push_gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self);
static void tarot_widget_select_straight_keep (TarotWidget* self);
static void _tarot_widget_select_straight_keep_gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self);
static void tarot_widget_select_double_keep (TarotWidget* self);
static void _tarot_widget_select_double_keep_gtk_button_clicked (GtkButton* _sender,
                                                          gpointer self);
static void tarot_widget_select_none (TarotWidget* self);
static void _tarot_widget_select_none_gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self);
static void tarot_widget_select_slam (TarotWidget* self);
static void _tarot_widget_select_slam_gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self);
static void tarot_widget_button_call_clicked (TarotWidget* self);
static void _tarot_widget_button_call_clicked_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self);
static void tarot_widget_valid_call_selection (TarotWidget* self);
static void _tarot_widget_valid_call_selection_tarot_card_selection_valid_selection (TarotCardSelection* _sender,
                                                                              gpointer self);
static void tarot_widget_invalid_call_selection (TarotWidget* self);
static void _tarot_widget_invalid_call_selection_tarot_card_selection_invalid_selection (TarotCardSelection* _sender,
                                                                                  gpointer self);
static void tarot_widget_button_discard_clicked (TarotWidget* self);
static void _tarot_widget_button_discard_clicked_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self);
static void tarot_widget_valid_discard_selection (TarotWidget* self);
static void _tarot_widget_valid_discard_selection_tarot_card_selection_valid_selection (TarotCardSelection* _sender,
                                                                                 gpointer self);
static void tarot_widget_invalid_discard_selection (TarotWidget* self);
static void _tarot_widget_invalid_discard_selection_tarot_card_selection_invalid_selection (TarotCardSelection* _sender,
                                                                                     gpointer self);
static void tarot_widget_button_handful_clicked (TarotWidget* self);
static void _tarot_widget_button_handful_clicked_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self);
static void tarot_widget_valid_handful_selection (TarotWidget* self);
static void _vala_TarotGameEvent_free (TarotGameEvent* self);
static void _tarot_widget_valid_handful_selection_tarot_card_selection_valid_selection (TarotCardSelection* _sender,
                                                                                 gpointer self);
static void tarot_widget_invalid_handful_selection (TarotWidget* self);
static void _tarot_widget_invalid_handful_selection_tarot_card_selection_invalid_selection (TarotCardSelection* _sender,
                                                                                     gpointer self);
static void _vala_array_add3 (TarotCard* * array,
                       gint* length,
                       gint* size,
                       TarotCard value);
static TarotCard* _vala_array_dup1 (TarotCard* self,
                             gssize length);
static TarotCard* _vala_array_dup2 (TarotCard* self,
                             gssize length);
static TarotCard* _vala_array_dup3 (TarotCard* self,
                             gssize length);
static TarotCard* _vala_array_dup4 (TarotCard* self,
                             gssize length);
static void _vala_array_add4 (TarotCard* * array,
                       gint* length,
                       gint* size,
                       TarotCard value);
static void _vala_array_add5 (gsize* * array,
                       gint* length,
                       gint* size,
                       gsize value);
static gchar* tarot_widget_compute_my_status_with_score (TarotWidget* self);
static gchar* tarot_widget_compute_my_status (TarotWidget* self,
                                       TarotPlayer myself);
static void tarot_widget_update_header_model (TarotWidget* self);
static TarotCard* tarot_widget_trick_content_aux (TarotWidget* self,
                                           TarotPlayer view,
                                           TarotPlayer* trick_taker,
                                           gsize trick,
                                           gint* result_length1);
static TarotCard* tarot_widget_trick_content (TarotWidget* self,
                                       TarotPlayer view,
                                       TarotPlayer* trick_taker,
                                       gint* result_length1);
static TarotCard* tarot_widget_center_content (TarotWidget* self,
                                        gint* result_length1);
static void tarot_widget_update (TarotWidget* self);
static void _vala_array_add6 (TarotCard* * array,
                       gint* length,
                       gint* size,
                       TarotCard value);
static void tarot_widget_card_selected (TarotWidget* self,
                                 gsize i_card);
static void tarot_widget_no_card_selected (TarotWidget* self);
static TarotGame* _vala_TarotGame_copy (TarotGame* self);
static void g_cclosure_user_marshal_VOID__POINTER_INT (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static GObject * tarot_widget_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static gboolean _tarot_widget___lambda21_ (TarotWidget* self,
                                    GdkEventMotion* motion,
                                    gsize i_card);
static gboolean __tarot_widget___lambda21__tarot_card_view_motion_notify_event_card (TarotCardView* _sender,
                                                                              GdkEventMotion* motion,
                                                                              gsize index,
                                                                              gpointer self);
static gboolean _tarot_widget___lambda22_ (TarotWidget* self,
                                    GdkEventMotion* motion);
static gboolean __tarot_widget___lambda22__tarot_card_view_motion_notify_event_no_card (TarotCardView* _sender,
                                                                                 GdkEventMotion* motion,
                                                                                 gpointer self);
static gboolean _tarot_widget___lambda23_ (TarotWidget* self,
                                    GdkEventMotion* motion,
                                    gsize i_card);
static gboolean __tarot_widget___lambda23__tarot_card_view_motion_notify_event_card (TarotCardView* _sender,
                                                                              GdkEventMotion* motion,
                                                                              gsize index,
                                                                              gpointer self);
static gboolean _tarot_widget___lambda24_ (TarotWidget* self,
                                    GdkEventMotion* motion);
static gboolean __tarot_widget___lambda24__tarot_card_view_motion_notify_event_no_card (TarotCardView* _sender,
                                                                                 GdkEventMotion* motion,
                                                                                 gpointer self);
static gboolean _tarot_widget___lambda25_ (TarotWidget* self,
                                    GdkEventMotion* motion,
                                    gsize i_card);
static gboolean __tarot_widget___lambda25__tarot_card_view_motion_notify_event_card (TarotCardView* _sender,
                                                                              GdkEventMotion* motion,
                                                                              gsize index,
                                                                              gpointer self);
static gboolean _tarot_widget___lambda26_ (TarotWidget* self,
                                    GdkEventMotion* motion);
static gboolean __tarot_widget___lambda26__tarot_card_view_motion_notify_event_no_card (TarotCardView* _sender,
                                                                                 GdkEventMotion* motion,
                                                                                 gpointer self);
static gboolean _tarot_widget___lambda27_ (TarotWidget* self,
                                    GdkEventButton* button,
                                    gsize i_card);
static gboolean __tarot_widget___lambda27__tarot_card_view_button_press_event_card (TarotCardView* _sender,
                                                                             GdkEventButton* button,
                                                                             gsize index,
                                                                             gpointer self);
static gboolean _tarot_widget___lambda28_ (TarotWidget* self,
                                    GdkEventButton* button);
static gboolean __tarot_widget___lambda28__tarot_card_view_button_press_event_no_card (TarotCardView* _sender,
                                                                                GdkEventButton* button,
                                                                                gpointer self);
static void _tarot_widget___lambda29_ (TarotWidget* self,
                                gint n);
static void __tarot_widget___lambda29__tarot_card_selection_n_remaining_cards_to_select (TarotCardSelection* _sender,
                                                                                  gint n,
                                                                                  gpointer self);
static void tarot_widget_finalize (GObject * obj);
static GType tarot_widget_get_type_once (void);
static void _vala_tarot_widget_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_tarot_widget_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
tarot_widget_get_instance_private (TarotWidget* self)
{
	return G_STRUCT_MEMBER_P (self, TarotWidget_private_offset);
}

static void
_vala_TarotGame_free (TarotGame* self)
{
	g_boxed_free (tarot_game_get_type (), self);
}

static void
tarot_widget_select_pass (TarotWidget* self)
{
	g_return_if_fail (self != NULL);
	tarot_widget_dont_ask (self);
	g_signal_emit (self, tarot_widget_signals[TAROT_WIDGET_SELECT_BID_SIGNAL], 0, TAROT_PASS);
}

static void
_tarot_widget_select_pass_gtk_button_clicked (GtkButton* _sender,
                                              gpointer self)
{
	tarot_widget_select_pass ((TarotWidget*) self);
}

static void
tarot_widget_select_take (TarotWidget* self)
{
	g_return_if_fail (self != NULL);
	tarot_widget_dont_ask (self);
	g_signal_emit (self, tarot_widget_signals[TAROT_WIDGET_SELECT_BID_SIGNAL], 0, TAROT_TAKE);
}

static void
_tarot_widget_select_take_gtk_button_clicked (GtkButton* _sender,
                                              gpointer self)
{
	tarot_widget_select_take ((TarotWidget*) self);
}

static void
tarot_widget_select_push (TarotWidget* self)
{
	g_return_if_fail (self != NULL);
	tarot_widget_dont_ask (self);
	g_signal_emit (self, tarot_widget_signals[TAROT_WIDGET_SELECT_BID_SIGNAL], 0, TAROT_PUSH);
}

static void
_tarot_widget_select_push_gtk_button_clicked (GtkButton* _sender,
                                              gpointer self)
{
	tarot_widget_select_push ((TarotWidget*) self);
}

static void
tarot_widget_select_straight_keep (TarotWidget* self)
{
	g_return_if_fail (self != NULL);
	tarot_widget_dont_ask (self);
	g_signal_emit (self, tarot_widget_signals[TAROT_WIDGET_SELECT_BID_SIGNAL], 0, TAROT_STRAIGHT_KEEP);
}

static void
_tarot_widget_select_straight_keep_gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self)
{
	tarot_widget_select_straight_keep ((TarotWidget*) self);
}

static void
tarot_widget_select_double_keep (TarotWidget* self)
{
	g_return_if_fail (self != NULL);
	tarot_widget_dont_ask (self);
	g_signal_emit (self, tarot_widget_signals[TAROT_WIDGET_SELECT_BID_SIGNAL], 0, TAROT_DOUBLE_KEEP);
}

static void
_tarot_widget_select_double_keep_gtk_button_clicked (GtkButton* _sender,
                                                     gpointer self)
{
	tarot_widget_select_double_keep ((TarotWidget*) self);
}

static void
tarot_widget_select_none (TarotWidget* self)
{
	g_return_if_fail (self != NULL);
	tarot_widget_dont_ask (self);
	g_signal_emit (self, tarot_widget_signals[TAROT_WIDGET_SELECT_DECLARATION_SIGNAL], 0, FALSE);
}

static void
_tarot_widget_select_none_gtk_button_clicked (GtkButton* _sender,
                                              gpointer self)
{
	tarot_widget_select_none ((TarotWidget*) self);
}

static void
tarot_widget_select_slam (TarotWidget* self)
{
	g_return_if_fail (self != NULL);
	tarot_widget_dont_ask (self);
	g_signal_emit (self, tarot_widget_signals[TAROT_WIDGET_SELECT_DECLARATION_SIGNAL], 0, TRUE);
}

static void
_tarot_widget_select_slam_gtk_button_clicked (GtkButton* _sender,
                                              gpointer self)
{
	tarot_widget_select_slam ((TarotWidget*) self);
}

static void
tarot_widget_button_call_clicked (TarotWidget* self)
{
	TarotCardSelection* _tmp0_;
	gint _tmp1_ = 0;
	TarotCard* _tmp2_;
	TarotCard* _tmp3_;
	gint _tmp3__length1;
	TarotCard _tmp4_;
	g_return_if_fail (self != NULL);
	tarot_widget_dont_ask (self);
	_tmp0_ = self->priv->call_selection;
	_tmp2_ = tarot_card_selection_get_selection (_tmp0_, &_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _tmp1_;
	_tmp4_ = _tmp3_[0];
	g_signal_emit (self, tarot_widget_signals[TAROT_WIDGET_SELECT_CALL_SIGNAL], 0, (guint) _tmp4_);
	_tmp3_ = (g_free (_tmp3_), NULL);
}

static void
_tarot_widget_button_call_clicked_gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self)
{
	tarot_widget_button_call_clicked ((TarotWidget*) self);
}

static void
tarot_widget_valid_call_selection (TarotWidget* self)
{
	GtkButton* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->button_call;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, TRUE);
}

static void
_tarot_widget_valid_call_selection_tarot_card_selection_valid_selection (TarotCardSelection* _sender,
                                                                         gpointer self)
{
	tarot_widget_valid_call_selection ((TarotWidget*) self);
}

static void
tarot_widget_invalid_call_selection (TarotWidget* self)
{
	GtkButton* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->button_call;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, FALSE);
}

static void
_tarot_widget_invalid_call_selection_tarot_card_selection_invalid_selection (TarotCardSelection* _sender,
                                                                             gpointer self)
{
	tarot_widget_invalid_call_selection ((TarotWidget*) self);
}

static void
tarot_widget_button_discard_clicked (TarotWidget* self)
{
	TarotCardSelection* _tmp0_;
	gint _tmp1_ = 0;
	TarotCard* _tmp2_;
	TarotCard* _tmp3_;
	gint _tmp3__length1;
	g_return_if_fail (self != NULL);
	tarot_widget_dont_ask (self);
	_tmp0_ = self->priv->discard_selection;
	_tmp2_ = tarot_card_selection_get_selection (_tmp0_, &_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _tmp1_;
	g_signal_emit (self, tarot_widget_signals[TAROT_WIDGET_SELECT_DISCARD_SIGNAL], 0, _tmp3_, (gint) _tmp1_);
	_tmp3_ = (g_free (_tmp3_), NULL);
}

static void
_tarot_widget_button_discard_clicked_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self)
{
	tarot_widget_button_discard_clicked ((TarotWidget*) self);
}

static void
tarot_widget_valid_discard_selection (TarotWidget* self)
{
	GtkButton* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->button_discard;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, TRUE);
}

static void
_tarot_widget_valid_discard_selection_tarot_card_selection_valid_selection (TarotCardSelection* _sender,
                                                                            gpointer self)
{
	tarot_widget_valid_discard_selection ((TarotWidget*) self);
}

static void
tarot_widget_invalid_discard_selection (TarotWidget* self)
{
	GtkButton* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->button_discard;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, FALSE);
}

static void
_tarot_widget_invalid_discard_selection_tarot_card_selection_invalid_selection (TarotCardSelection* _sender,
                                                                                gpointer self)
{
	tarot_widget_invalid_discard_selection ((TarotWidget*) self);
}

static void
tarot_widget_button_handful_clicked (TarotWidget* self)
{
	TarotCardSelection* _tmp0_;
	gint _tmp1_ = 0;
	TarotCard* _tmp2_;
	TarotCard* _tmp3_;
	gint _tmp3__length1;
	g_return_if_fail (self != NULL);
	tarot_widget_dont_ask (self);
	_tmp0_ = self->priv->handful_selection;
	_tmp2_ = tarot_card_selection_get_selection (_tmp0_, &_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _tmp1_;
	g_signal_emit (self, tarot_widget_signals[TAROT_WIDGET_SELECT_HANDFUL_SIGNAL], 0, _tmp3_, (gint) _tmp1_);
	_tmp3_ = (g_free (_tmp3_), NULL);
}

static void
_tarot_widget_button_handful_clicked_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self)
{
	tarot_widget_button_handful_clicked ((TarotWidget*) self);
}

static void
_vala_TarotGameEvent_free (TarotGameEvent* self)
{
	g_boxed_free (tarot_game_event_get_type (), self);
}

static void
tarot_widget_valid_handful_selection (TarotWidget* self)
{
	TarotGameEvent* e = NULL;
	TarotCardSelection* _tmp0_;
	gint _tmp1_ = 0;
	TarotCard* _tmp2_;
	TarotCard* _tmp3_;
	gint _tmp3__length1;
	TarotGameEvent* _tmp4_;
	TarotGameEvent* _tmp5_;
	GtkButton* _tmp6_;
	TarotGame* _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->handful_selection;
	_tmp2_ = tarot_card_selection_get_selection (_tmp0_, &_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _tmp1_;
	_tmp4_ = tarot_game_event_alloc_handful (_tmp1_, _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp3_ = (g_free (_tmp3_), NULL);
	e = _tmp5_;
	_tmp6_ = self->priv->button_handful;
	_tmp7_ = self->priv->current_game;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, tarot_game_check_event (_tmp7_, e));
	__vala_TarotGameEvent_free0 (e);
}

static void
_tarot_widget_valid_handful_selection_tarot_card_selection_valid_selection (TarotCardSelection* _sender,
                                                                            gpointer self)
{
	tarot_widget_valid_handful_selection ((TarotWidget*) self);
}

static void
tarot_widget_invalid_handful_selection (TarotWidget* self)
{
	g_return_if_fail (self != NULL);
	tarot_widget_valid_handful_selection (self);
}

static void
_tarot_widget_invalid_handful_selection_tarot_card_selection_invalid_selection (TarotCardSelection* _sender,
                                                                                gpointer self)
{
	tarot_widget_invalid_handful_selection ((TarotWidget*) self);
}

void
tarot_widget_ask_bid (TarotWidget* self,
                      TarotBid minimum)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
	GtkStack* _tmp14_;
	GtkFlowBox* _tmp15_;
	GtkStack* _tmp16_;
	GtkWidget* _tmp17_;
	GtkWidget* _tmp18_;
	GtkFlowBox* _tmp19_;
	GtkStack* _tmp20_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->button_double_keep;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, FALSE);
	_tmp1_ = self->priv->button_straight_keep;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, FALSE);
	_tmp2_ = self->priv->button_push;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, FALSE);
	_tmp3_ = self->priv->button_take;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, FALSE);
	switch (minimum) {
		case TAROT_PASS:
		case TAROT_TAKE:
		{
			GtkButton* _tmp4_;
			GtkButton* _tmp5_;
			GtkButton* _tmp6_;
			GtkButton* _tmp7_;
			_tmp4_ = self->priv->button_double_keep;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, TRUE);
			_tmp5_ = self->priv->button_straight_keep;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, TRUE);
			_tmp6_ = self->priv->button_push;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, TRUE);
			_tmp7_ = self->priv->button_take;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, TRUE);
			break;
		}
		case TAROT_PUSH:
		{
			GtkButton* _tmp8_;
			GtkButton* _tmp9_;
			GtkButton* _tmp10_;
			_tmp8_ = self->priv->button_double_keep;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, TRUE);
			_tmp9_ = self->priv->button_straight_keep;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, TRUE);
			_tmp10_ = self->priv->button_push;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, TRUE);
			break;
		}
		case TAROT_STRAIGHT_KEEP:
		{
			GtkButton* _tmp11_;
			GtkButton* _tmp12_;
			_tmp11_ = self->priv->button_double_keep;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp11_, TRUE);
			_tmp12_ = self->priv->button_straight_keep;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp12_, TRUE);
			break;
		}
		case TAROT_DOUBLE_KEEP:
		{
			GtkButton* _tmp13_;
			_tmp13_ = self->priv->button_double_keep;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, TRUE);
			break;
		}
		default:
		break;
	}
	_tmp14_ = self->priv->entry_stack;
	_tmp15_ = self->priv->widget_bid;
	gtk_stack_set_visible_child (_tmp14_, (GtkWidget*) _tmp15_);
	_tmp16_ = self->priv->entry_stack;
	_tmp17_ = gtk_stack_get_visible_child (_tmp16_);
	_tmp18_ = _tmp17_;
	_tmp19_ = self->priv->widget_bid;
	_vala_assert (_tmp18_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_widget_get_type (), GtkWidget), "entry_stack.visible_child == widget_bid");
	_tmp20_ = self->priv->entry_stack;
	gtk_widget_show ((GtkWidget*) _tmp20_);
}

void
tarot_widget_ask_declaration (TarotWidget* self,
                              gboolean allowed)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, tarot_widget_signals[TAROT_WIDGET_SELECT_DECLARATION_SIGNAL], 0, FALSE);
}

static void
_vala_array_add3 (TarotCard* * array,
                  gint* length,
                  gint* size,
                  TarotCard value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (TarotCard, *array, *size);
	}
	(*array)[(*length)++] = value;
}

void
tarot_widget_ask_call (TarotWidget* self,
                       TarotNumber mini)
{
	TarotSuit* suits = NULL;
	TarotSuit* _tmp0_;
	gint suits_length1;
	gint _suits_size_;
	TarotNumber jack = 0U;
	TarotNumber knight = 0U;
	TarotNumber queen = 0U;
	TarotNumber king = 0U;
	TarotCard* possible = NULL;
	TarotCard* _tmp1_;
	gint possible_length1;
	gint _possible_size_;
	TarotCardSelection* _tmp7_;
	TarotCard* _tmp8_;
	TarotCard* _tmp9_;
	gint _tmp9__length1;
	TarotCardSelection* _tmp10_;
	TarotCard* _tmp11_;
	gint _tmp11__length1;
	TarotCardSelection* _tmp12_;
	GtkStack* _tmp13_;
	GtkBox* _tmp14_;
	GtkStack* _tmp15_;
	GtkWidget* _tmp16_;
	GtkWidget* _tmp17_;
	GtkBox* _tmp18_;
	GtkStack* _tmp19_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_new0 (TarotSuit, 4);
	_tmp0_[0] = TAROT_HEARTS;
	_tmp0_[1] = TAROT_CLUBS;
	_tmp0_[2] = TAROT_DIAMONDS;
	_tmp0_[3] = TAROT_SPADES;
	suits = _tmp0_;
	suits_length1 = 4;
	_suits_size_ = suits_length1;
	jack = (TarotNumber) (10 + 1);
	knight = jack + 1;
	queen = knight + 1;
	king = queen + 1;
	_tmp1_ = g_new0 (TarotCard, 0);
	possible = _tmp1_;
	possible_length1 = 0;
	_possible_size_ = possible_length1;
	{
		TarotNumber i = 0U;
		i = mini;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				TarotSuit* _tmp4_;
				gint _tmp4__length1;
				if (!_tmp2_) {
					TarotNumber _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				if (!(i <= king)) {
					break;
				}
				_tmp4_ = suits;
				_tmp4__length1 = suits_length1;
				{
					TarotSuit* s_collection = NULL;
					gint s_collection_length1 = 0;
					gint _s_collection_size_ = 0;
					gint s_it = 0;
					s_collection = _tmp4_;
					s_collection_length1 = _tmp4__length1;
					for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
						TarotSuit s = 0;
						s = s_collection[s_it];
						{
							TarotCard added = 0U;
							TarotCard _tmp5_ = 0U;
							gint _tmp6_;
							_tmp6_ = tarot_of (i, s, &_tmp5_);
							added = _tmp5_;
							if (_tmp6_ != 0) {
								_vala_assert (FALSE, "false");
							}
							_vala_array_add3 (&possible, &possible_length1, &_possible_size_, added);
						}
					}
				}
			}
		}
	}
	_tmp7_ = self->priv->call_selection;
	_tmp8_ = g_new0 (TarotCard, 0);
	_tmp9_ = _tmp8_;
	_tmp9__length1 = 0;
	tarot_card_selection_set_forced (_tmp7_, _tmp9_, (gint) 0);
	_tmp9_ = (g_free (_tmp9_), NULL);
	_tmp10_ = self->priv->call_selection;
	_tmp11_ = possible;
	_tmp11__length1 = possible_length1;
	tarot_card_selection_set_optional (_tmp10_, _tmp11_, (gint) _tmp11__length1);
	_tmp12_ = self->priv->call_selection;
	tarot_card_selection_set_n_optional (_tmp12_, (gsize) 1);
	_tmp13_ = self->priv->entry_stack;
	_tmp14_ = self->priv->widget_call;
	gtk_stack_set_visible_child (_tmp13_, (GtkWidget*) _tmp14_);
	_tmp15_ = self->priv->entry_stack;
	_tmp16_ = gtk_stack_get_visible_child (_tmp15_);
	_tmp17_ = _tmp16_;
	_tmp18_ = self->priv->widget_call;
	_vala_assert (_tmp17_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, gtk_widget_get_type (), GtkWidget), "entry_stack.visible_child == widget_call");
	_tmp19_ = self->priv->entry_stack;
	gtk_widget_show ((GtkWidget*) _tmp19_);
	possible = (g_free (possible), NULL);
	suits = (g_free (suits), NULL);
}

static TarotCard*
_vala_array_dup1 (TarotCard* self,
                  gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (TarotCard));
	}
	return NULL;
}

static TarotCard*
_vala_array_dup2 (TarotCard* self,
                  gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (TarotCard));
	}
	return NULL;
}

static TarotCard*
_vala_array_dup3 (TarotCard* self,
                  gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (TarotCard));
	}
	return NULL;
}

void
tarot_widget_ask_discard (TarotWidget* self,
                          gsize n,
                          TarotCard* prio,
                          gint prio_length1,
                          TarotCard* additional,
                          gint additional_length1)
{
	TarotCard* forced = NULL;
	TarotCard* _tmp0_;
	gint forced_length1;
	gint _forced_size_;
	TarotCard* optional = NULL;
	TarotCard* _tmp1_;
	gint _tmp1__length1;
	gint optional_length1;
	gint _optional_size_;
	gsize n_optional = 0UL;
	TarotCardSelection* _tmp4_;
	TarotCard* _tmp5_;
	gint _tmp5__length1;
	TarotCardSelection* _tmp6_;
	TarotCard* _tmp7_;
	gint _tmp7__length1;
	TarotCardSelection* _tmp8_;
	GtkStack* _tmp9_;
	GtkBox* _tmp10_;
	GtkStack* _tmp11_;
	GtkWidget* _tmp12_;
	GtkWidget* _tmp13_;
	GtkBox* _tmp14_;
	GtkStack* _tmp15_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_new0 (TarotCard, 0);
	forced = _tmp0_;
	forced_length1 = 0;
	_forced_size_ = forced_length1;
	_tmp1_ = (prio != NULL) ? _vala_array_dup1 (prio, prio_length1) : prio;
	_tmp1__length1 = prio_length1;
	optional = _tmp1_;
	optional_length1 = _tmp1__length1;
	_optional_size_ = optional_length1;
	n_optional = n;
	if (n >= ((gsize) prio_length1)) {
		TarotCard* _tmp2_;
		gint _tmp2__length1;
		TarotCard* _tmp3_;
		gint _tmp3__length1;
		_tmp2_ = (prio != NULL) ? _vala_array_dup2 (prio, prio_length1) : prio;
		_tmp2__length1 = prio_length1;
		forced = (g_free (forced), NULL);
		forced = _tmp2_;
		forced_length1 = _tmp2__length1;
		_forced_size_ = forced_length1;
		_tmp3_ = (additional != NULL) ? _vala_array_dup3 (additional, additional_length1) : additional;
		_tmp3__length1 = additional_length1;
		optional = (g_free (optional), NULL);
		optional = _tmp3_;
		optional_length1 = _tmp3__length1;
		_optional_size_ = optional_length1;
		n_optional = n - prio_length1;
	}
	_tmp4_ = self->priv->discard_selection;
	_tmp5_ = forced;
	_tmp5__length1 = forced_length1;
	tarot_card_selection_set_forced (_tmp4_, _tmp5_, (gint) _tmp5__length1);
	_tmp6_ = self->priv->discard_selection;
	_tmp7_ = optional;
	_tmp7__length1 = optional_length1;
	tarot_card_selection_set_optional (_tmp6_, _tmp7_, (gint) _tmp7__length1);
	_tmp8_ = self->priv->discard_selection;
	tarot_card_selection_set_n_optional (_tmp8_, n_optional);
	_tmp9_ = self->priv->entry_stack;
	_tmp10_ = self->priv->widget_discard;
	gtk_stack_set_visible_child (_tmp9_, (GtkWidget*) _tmp10_);
	_tmp11_ = self->priv->entry_stack;
	_tmp12_ = gtk_stack_get_visible_child (_tmp11_);
	_tmp13_ = _tmp12_;
	_tmp14_ = self->priv->widget_discard;
	_vala_assert (_tmp13_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_widget_get_type (), GtkWidget), "entry_stack.visible_child == widget_discard");
	_tmp15_ = self->priv->entry_stack;
	gtk_widget_show ((GtkWidget*) _tmp15_);
	optional = (g_free (optional), NULL);
	forced = (g_free (forced), NULL);
}

static TarotCard*
_vala_array_dup4 (TarotCard* self,
                  gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (TarotCard));
	}
	return NULL;
}

static void
_vala_array_add4 (TarotCard* * array,
                  gint* length,
                  gint* size,
                  TarotCard value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (TarotCard, *array, *size);
	}
	(*array)[(*length)++] = value;
}

void
tarot_widget_ask_handful (TarotWidget* self,
                          gsize n_simple,
                          gsize n_double,
                          gsize n_triple,
                          TarotCard* prio,
                          gint prio_length1,
                          TarotCard* additional,
                          gint additional_length1)
{
	TarotCard* forced = NULL;
	TarotCard* _tmp0_;
	gint forced_length1;
	gint _forced_size_;
	TarotCard* optional = NULL;
	TarotCard* _tmp1_;
	gint _tmp1__length1;
	gint optional_length1;
	gint _optional_size_;
	gsize n_optional = 0UL;
	TarotCardSelection* _tmp2_;
	TarotCard* _tmp3_;
	gint _tmp3__length1;
	TarotCardSelection* _tmp4_;
	TarotCard* _tmp5_;
	gint _tmp5__length1;
	TarotCardSelection* _tmp6_;
	GtkStack* _tmp7_;
	GtkBox* _tmp8_;
	GtkStack* _tmp9_;
	GtkWidget* _tmp10_;
	GtkWidget* _tmp11_;
	GtkBox* _tmp12_;
	GtkStack* _tmp13_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_new0 (TarotCard, 0);
	forced = _tmp0_;
	forced_length1 = 0;
	_forced_size_ = forced_length1;
	_tmp1_ = (prio != NULL) ? _vala_array_dup4 (prio, prio_length1) : prio;
	_tmp1__length1 = prio_length1;
	optional = _tmp1_;
	optional_length1 = _tmp1__length1;
	_optional_size_ = optional_length1;
	{
		TarotCard* c_collection = NULL;
		gint c_collection_length1 = 0;
		gint _c_collection_size_ = 0;
		gint c_it = 0;
		c_collection = additional;
		c_collection_length1 = additional_length1;
		for (c_it = 0; c_it < c_collection_length1; c_it = c_it + 1) {
			TarotCard c = 0U;
			c = c_collection[c_it];
			{
				_vala_array_add4 (&optional, &optional_length1, &_optional_size_, c);
			}
		}
	}
	n_optional = n_simple;
	_tmp2_ = self->priv->handful_selection;
	_tmp3_ = forced;
	_tmp3__length1 = forced_length1;
	tarot_card_selection_set_forced (_tmp2_, _tmp3_, (gint) _tmp3__length1);
	_tmp4_ = self->priv->handful_selection;
	_tmp5_ = optional;
	_tmp5__length1 = optional_length1;
	tarot_card_selection_set_optional (_tmp4_, _tmp5_, (gint) _tmp5__length1);
	_tmp6_ = self->priv->handful_selection;
	tarot_card_selection_set_n_optional (_tmp6_, n_optional);
	_tmp7_ = self->priv->entry_stack;
	_tmp8_ = self->priv->widget_handful;
	gtk_stack_set_visible_child (_tmp7_, (GtkWidget*) _tmp8_);
	_tmp9_ = self->priv->entry_stack;
	_tmp10_ = gtk_stack_get_visible_child (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = self->priv->widget_handful;
	_vala_assert (_tmp11_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_widget_get_type (), GtkWidget), "entry_stack.visible_child == widget_handful");
	_tmp13_ = self->priv->entry_stack;
	gtk_widget_show ((GtkWidget*) _tmp13_);
	optional = (g_free (optional), NULL);
	forced = (g_free (forced), NULL);
}

static void
_vala_array_add5 (gsize* * array,
                  gint* length,
                  gint* size,
                  gsize value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gsize, *array, *size);
	}
	(*array)[(*length)++] = value;
}

void
tarot_widget_ask_play (TarotWidget* self,
                       TarotCard* playable,
                       gint playable_length1)
{
	gboolean* is_playable = NULL;
	gboolean* _tmp0_;
	gint is_playable_length1;
	gint _is_playable_size_;
	gsize* i = NULL;
	gsize* _tmp5_;
	gint i_length1;
	gint _i_size_;
	TarotCard* all_cards = NULL;
	TarotFanCardView* _tmp6_;
	gint _tmp7_ = 0;
	TarotCard* _tmp8_;
	gint all_cards_length1;
	gint _all_cards_size_;
	TarotFanCardView* _tmp16_;
	gsize* _tmp17_;
	gint _tmp17__length1;
	g_return_if_fail (self != NULL);
	self->priv->allow_play = TRUE;
	_tmp0_ = g_new0 (gboolean, 78);
	is_playable = _tmp0_;
	is_playable_length1 = 78;
	_is_playable_size_ = is_playable_length1;
	{
		gsize i = 0UL;
		i = (gsize) 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gboolean* _tmp3_;
				gint _tmp3__length1;
				if (!_tmp1_) {
					gsize _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(i < ((gsize) 78))) {
					break;
				}
				_tmp3_ = is_playable;
				_tmp3__length1 = is_playable_length1;
				_tmp3_[i] = FALSE;
			}
		}
	}
	{
		TarotCard* c_collection = NULL;
		gint c_collection_length1 = 0;
		gint _c_collection_size_ = 0;
		gint c_it = 0;
		c_collection = playable;
		c_collection_length1 = playable_length1;
		for (c_it = 0; c_it < c_collection_length1; c_it = c_it + 1) {
			TarotCard c = 0U;
			c = c_collection[c_it];
			{
				gboolean* _tmp4_;
				gint _tmp4__length1;
				_tmp4_ = is_playable;
				_tmp4__length1 = is_playable_length1;
				_tmp4_[(gint) c] = TRUE;
			}
		}
	}
	_tmp5_ = g_new0 (gsize, 0);
	i = _tmp5_;
	i_length1 = 0;
	_i_size_ = i_length1;
	_tmp6_ = self->priv->hand_widget;
	_tmp8_ = tarot_card_view_get_cards ((TarotCardView*) _tmp6_, &_tmp7_);
	all_cards = _tmp8_;
	all_cards_length1 = _tmp7_;
	_all_cards_size_ = all_cards_length1;
	{
		gsize j = 0UL;
		j = (gsize) 0;
		{
			gboolean _tmp9_ = FALSE;
			_tmp9_ = TRUE;
			while (TRUE) {
				TarotCard* _tmp11_;
				gint _tmp11__length1;
				gboolean* _tmp12_;
				gint _tmp12__length1;
				TarotCard* _tmp13_;
				gint _tmp13__length1;
				TarotCard _tmp14_;
				gboolean _tmp15_;
				if (!_tmp9_) {
					gsize _tmp10_;
					_tmp10_ = j;
					j = _tmp10_ + 1;
				}
				_tmp9_ = FALSE;
				_tmp11_ = all_cards;
				_tmp11__length1 = all_cards_length1;
				if (!(j < ((gsize) _tmp11__length1))) {
					break;
				}
				_tmp12_ = is_playable;
				_tmp12__length1 = is_playable_length1;
				_tmp13_ = all_cards;
				_tmp13__length1 = all_cards_length1;
				_tmp14_ = _tmp13_[j];
				_tmp15_ = _tmp12_[_tmp14_];
				if (_tmp15_) {
					_vala_array_add5 (&i, &i_length1, &_i_size_, j);
				}
			}
		}
	}
	_tmp16_ = self->priv->hand_widget;
	_tmp17_ = i;
	_tmp17__length1 = i_length1;
	tarot_card_view_set_selectable ((TarotCardView*) _tmp16_, _tmp17_, (gint) _tmp17__length1);
	all_cards = (g_free (all_cards), NULL);
	i = (g_free (i), NULL);
	is_playable = (g_free (is_playable), NULL);
}

void
tarot_widget_dont_ask (TarotWidget* self)
{
	GtkStack* _tmp0_;
	gsize* empty_selectable = NULL;
	gsize* _tmp1_;
	gint empty_selectable_length1;
	gint _empty_selectable_size_;
	TarotFanCardView* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->entry_stack;
	gtk_widget_hide ((GtkWidget*) _tmp0_);
	self->priv->allow_play = FALSE;
	_tmp1_ = g_new0 (gsize, 0);
	empty_selectable = _tmp1_;
	empty_selectable_length1 = 0;
	_empty_selectable_size_ = empty_selectable_length1;
	_tmp2_ = self->priv->hand_widget;
	tarot_card_view_set_selectable ((TarotCardView*) _tmp2_, empty_selectable, (gint) empty_selectable_length1);
	empty_selectable = (g_free (empty_selectable), NULL);
}

static gchar*
tarot_widget_compute_my_status_with_score (TarotWidget* self)
{
	TarotPlayer myself = 0U;
	TarotGame* _tmp0_;
	TarotPlayer _tmp1_ = 0U;
	TarotGameError _tmp2_;
	gint* scores = NULL;
	gint scores_length1 = 0;
	gint _scores_size_ = 0;
	TarotGame* _tmp3_;
	gint* _tmp4_ = NULL;
	gsize _tmp5_ = 0;
	TarotGameError _tmp6_;
	gchar* _tmp21_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->current_game;
	_tmp2_ = tarot_game_get_main_player (_tmp0_, &_tmp1_);
	myself = _tmp1_;
	if (_tmp2_ != TAROT_GAME_OK) {
		myself = (TarotPlayer) 0;
	}
	_tmp3_ = self->priv->current_game;
	_tmp6_ = tarot_game_get_scores_alloc (_tmp3_, &_tmp5_, &_tmp4_);
	scores = (g_free (scores), NULL);
	scores = _tmp4_;
	scores_length1 = _tmp5_;
	_scores_size_ = scores_length1;
	if (_tmp6_ == TAROT_GAME_OK) {
		gint* _tmp7_;
		gint _tmp7__length1;
		gint _tmp8_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gint* _tmp17_;
		gint _tmp17__length1;
		gint _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		_tmp7_ = scores;
		_tmp7__length1 = scores_length1;
		_tmp8_ = _tmp7_[myself];
		if ((_tmp8_ % 2) == 0) {
			gchar* _tmp9_;
			gchar* _tmp10_;
			gint* _tmp11_;
			gint _tmp11__length1;
			gint _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			_tmp9_ = tarot_widget_compute_my_status (self, myself);
			_tmp10_ = _tmp9_;
			_tmp11_ = scores;
			_tmp11__length1 = scores_length1;
			_tmp12_ = _tmp11_[myself];
			_tmp13_ = g_strdup_printf (_ ("%s\nScore: %d"), _tmp10_, _tmp12_ / 2);
			_tmp14_ = _tmp13_;
			_g_free0 (_tmp10_);
			result = _tmp14_;
			scores = (g_free (scores), NULL);
			return result;
		}
		_tmp15_ = tarot_widget_compute_my_status (self, myself);
		_tmp16_ = _tmp15_;
		_tmp17_ = scores;
		_tmp17__length1 = scores_length1;
		_tmp18_ = _tmp17_[myself];
		_tmp19_ = g_strdup_printf (_ ("%s\nScore: %d.5"), _tmp16_, _tmp18_ / 2);
		_tmp20_ = _tmp19_;
		_g_free0 (_tmp16_);
		result = _tmp20_;
		scores = (g_free (scores), NULL);
		return result;
	}
	_tmp21_ = tarot_widget_compute_my_status (self, myself);
	result = _tmp21_;
	scores = (g_free (scores), NULL);
	return result;
}

static gchar*
tarot_widget_compute_my_status (TarotWidget* self,
                                TarotPlayer myself)
{
	TarotPlayer taker = 0U;
	TarotGame* _tmp0_;
	TarotPlayer _tmp1_ = 0U;
	TarotBid* bids = NULL;
	gint bids_length1 = 0;
	gint _bids_size_ = 0;
	TarotPlayer partner = 0U;
	gboolean _tmp2_ = FALSE;
	TarotGame* _tmp3_;
	TarotBid* _tmp4_ = NULL;
	gsize _tmp5_ = 0;
	TarotGameError _tmp6_;
	gchar* _tmp116_;
	gchar* _tmp117_;
	gchar* _tmp118_;
	gchar* _tmp119_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->current_game;
	tarot_game_get_taker (_tmp0_, &_tmp1_);
	taker = _tmp1_;
	_tmp3_ = self->priv->current_game;
	_tmp6_ = tarot_game_get_bids_alloc (_tmp3_, &_tmp5_, &_tmp4_);
	bids = (g_free (bids), NULL);
	bids = _tmp4_;
	bids_length1 = _tmp5_;
	_bids_size_ = bids_length1;
	if (_tmp6_ == TAROT_GAME_OK) {
		TarotBid* _tmp7_;
		gint _tmp7__length1;
		_tmp7_ = bids;
		_tmp7__length1 = bids_length1;
		_tmp2_ = ((TarotPlayer) _tmp7__length1) > myself;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		if (taker == myself) {
			TarotPlayer declarant = 0U;
			gboolean _tmp8_ = FALSE;
			TarotGame* _tmp9_;
			TarotPlayer _tmp10_ = 0U;
			TarotGameError _tmp11_;
			_tmp9_ = self->priv->current_game;
			_tmp11_ = tarot_game_get_declarant (_tmp9_, &_tmp10_);
			declarant = _tmp10_;
			if (_tmp11_ == TAROT_GAME_OK) {
				_tmp8_ = declarant == myself;
			} else {
				_tmp8_ = FALSE;
			}
			if (_tmp8_) {
				TarotBid* _tmp12_;
				gint _tmp12__length1;
				TarotBid _tmp13_;
				_tmp12_ = bids;
				_tmp12__length1 = bids_length1;
				_tmp13_ = _tmp12_[taker];
				switch (_tmp13_) {
					case TAROT_PASS:
					{
						gchar* _tmp14_;
						gchar* _tmp15_;
						gchar* _tmp16_;
						gchar* _tmp17_;
						_tmp14_ = tarot_player_to_string_alloc (myself);
						_tmp15_ = _tmp14_;
						_tmp16_ = g_strdup_printf (_ ("%s slams!"), _tmp15_);
						_tmp17_ = _tmp16_;
						_g_free0 (_tmp15_);
						result = _tmp17_;
						bids = (g_free (bids), NULL);
						return result;
					}
					case TAROT_TAKE:
					{
						gchar* _tmp18_;
						gchar* _tmp19_;
						gchar* _tmp20_;
						gchar* _tmp21_;
						_tmp18_ = tarot_player_to_string_alloc (myself);
						_tmp19_ = _tmp18_;
						_tmp20_ = g_strdup_printf (_ ("%s takes with slam!"), _tmp19_);
						_tmp21_ = _tmp20_;
						_g_free0 (_tmp19_);
						result = _tmp21_;
						bids = (g_free (bids), NULL);
						return result;
					}
					case TAROT_PUSH:
					{
						gchar* _tmp22_;
						gchar* _tmp23_;
						gchar* _tmp24_;
						gchar* _tmp25_;
						_tmp22_ = tarot_player_to_string_alloc (myself);
						_tmp23_ = _tmp22_;
						_tmp24_ = g_strdup_printf (_ ("%s pushes with slam!"), _tmp23_);
						_tmp25_ = _tmp24_;
						_g_free0 (_tmp23_);
						result = _tmp25_;
						bids = (g_free (bids), NULL);
						return result;
					}
					case TAROT_STRAIGHT_KEEP:
					{
						gchar* _tmp26_;
						gchar* _tmp27_;
						gchar* _tmp28_;
						gchar* _tmp29_;
						_tmp26_ = tarot_player_to_string_alloc (myself);
						_tmp27_ = _tmp26_;
						_tmp28_ = g_strdup_printf (_ ("%s keeps with slam!"), _tmp27_);
						_tmp29_ = _tmp28_;
						_g_free0 (_tmp27_);
						result = _tmp29_;
						bids = (g_free (bids), NULL);
						return result;
					}
					case TAROT_DOUBLE_KEEP:
					{
						gchar* _tmp30_;
						gchar* _tmp31_;
						gchar* _tmp32_;
						gchar* _tmp33_;
						_tmp30_ = tarot_player_to_string_alloc (myself);
						_tmp31_ = _tmp30_;
						_tmp32_ = g_strdup_printf (_ ("%s keeps (double, with slam)!"), _tmp31_);
						_tmp33_ = _tmp32_;
						_g_free0 (_tmp31_);
						result = _tmp33_;
						bids = (g_free (bids), NULL);
						return result;
					}
					default:
					break;
				}
			} else {
				TarotBid* _tmp34_;
				gint _tmp34__length1;
				TarotBid _tmp35_;
				_tmp34_ = bids;
				_tmp34__length1 = bids_length1;
				_tmp35_ = _tmp34_[taker];
				switch (_tmp35_) {
					case TAROT_PASS:
					{
						gchar* _tmp36_;
						gchar* _tmp37_;
						gchar* _tmp38_;
						gchar* _tmp39_;
						_tmp36_ = tarot_player_to_string_alloc (myself);
						_tmp37_ = _tmp36_;
						_tmp38_ = g_strdup_printf (_ ("%s (pass)"), _tmp37_);
						_tmp39_ = _tmp38_;
						_g_free0 (_tmp37_);
						result = _tmp39_;
						bids = (g_free (bids), NULL);
						return result;
					}
					case TAROT_TAKE:
					{
						gchar* _tmp40_;
						gchar* _tmp41_;
						gchar* _tmp42_;
						gchar* _tmp43_;
						_tmp40_ = tarot_player_to_string_alloc (myself);
						_tmp41_ = _tmp40_;
						_tmp42_ = g_strdup_printf (_ ("%s takes."), _tmp41_);
						_tmp43_ = _tmp42_;
						_g_free0 (_tmp41_);
						result = _tmp43_;
						bids = (g_free (bids), NULL);
						return result;
					}
					case TAROT_PUSH:
					{
						gchar* _tmp44_;
						gchar* _tmp45_;
						gchar* _tmp46_;
						gchar* _tmp47_;
						_tmp44_ = tarot_player_to_string_alloc (myself);
						_tmp45_ = _tmp44_;
						_tmp46_ = g_strdup_printf (_ ("%s pushes."), _tmp45_);
						_tmp47_ = _tmp46_;
						_g_free0 (_tmp45_);
						result = _tmp47_;
						bids = (g_free (bids), NULL);
						return result;
					}
					case TAROT_STRAIGHT_KEEP:
					{
						gchar* _tmp48_;
						gchar* _tmp49_;
						gchar* _tmp50_;
						gchar* _tmp51_;
						_tmp48_ = tarot_player_to_string_alloc (myself);
						_tmp49_ = _tmp48_;
						_tmp50_ = g_strdup_printf (_ ("%s keeps."), _tmp49_);
						_tmp51_ = _tmp50_;
						_g_free0 (_tmp49_);
						result = _tmp51_;
						bids = (g_free (bids), NULL);
						return result;
					}
					case TAROT_DOUBLE_KEEP:
					{
						gchar* _tmp52_;
						gchar* _tmp53_;
						gchar* _tmp54_;
						gchar* _tmp55_;
						_tmp52_ = tarot_player_to_string_alloc (myself);
						_tmp53_ = _tmp52_;
						_tmp54_ = g_strdup_printf (_ ("%s keeps (double)."), _tmp53_);
						_tmp55_ = _tmp54_;
						_g_free0 (_tmp53_);
						result = _tmp55_;
						bids = (g_free (bids), NULL);
						return result;
					}
					default:
					break;
				}
			}
		} else {
			gboolean _tmp56_ = FALSE;
			TarotGame* _tmp57_;
			TarotPlayer _tmp58_ = 0U;
			TarotGameError _tmp59_;
			_tmp57_ = self->priv->current_game;
			_tmp59_ = tarot_game_get_partner (_tmp57_, &_tmp58_);
			partner = _tmp58_;
			if (_tmp59_ == TAROT_GAME_OK) {
				_tmp56_ = partner == myself;
			} else {
				_tmp56_ = FALSE;
			}
			if (_tmp56_) {
				TarotPlayer declarant = 0U;
				gboolean _tmp60_ = FALSE;
				TarotGame* _tmp61_;
				TarotPlayer _tmp62_ = 0U;
				TarotGameError _tmp63_;
				_tmp61_ = self->priv->current_game;
				_tmp63_ = tarot_game_get_declarant (_tmp61_, &_tmp62_);
				declarant = _tmp62_;
				if (_tmp63_ == TAROT_GAME_OK) {
					_tmp60_ = declarant == myself;
				} else {
					_tmp60_ = FALSE;
				}
				if (_tmp60_) {
					gchar* _tmp64_;
					gchar* _tmp65_;
					gchar* _tmp66_;
					gchar* _tmp67_;
					_tmp64_ = tarot_player_to_string_alloc (myself);
					_tmp65_ = _tmp64_;
					_tmp66_ = g_strdup_printf (_ ("%s (called) slams!"), _tmp65_);
					_tmp67_ = _tmp66_;
					_g_free0 (_tmp65_);
					result = _tmp67_;
					bids = (g_free (bids), NULL);
					return result;
				} else {
					gchar* _tmp68_;
					gchar* _tmp69_;
					gchar* _tmp70_;
					gchar* _tmp71_;
					_tmp68_ = tarot_player_to_string_alloc (myself);
					_tmp69_ = _tmp68_;
					_tmp70_ = g_strdup_printf (_ ("%s (called)"), _tmp69_);
					_tmp71_ = _tmp70_;
					_g_free0 (_tmp69_);
					result = _tmp71_;
					bids = (g_free (bids), NULL);
					return result;
				}
			} else {
				TarotPlayer declarant = 0U;
				gboolean _tmp72_ = FALSE;
				TarotGame* _tmp73_;
				TarotPlayer _tmp74_ = 0U;
				TarotGameError _tmp75_;
				_tmp73_ = self->priv->current_game;
				_tmp75_ = tarot_game_get_declarant (_tmp73_, &_tmp74_);
				declarant = _tmp74_;
				if (_tmp75_ == TAROT_GAME_OK) {
					_tmp72_ = declarant == myself;
				} else {
					_tmp72_ = FALSE;
				}
				if (_tmp72_) {
					TarotBid* _tmp76_;
					gint _tmp76__length1;
					TarotBid _tmp77_;
					_tmp76_ = bids;
					_tmp76__length1 = bids_length1;
					_tmp77_ = _tmp76_[myself];
					switch (_tmp77_) {
						case TAROT_PASS:
						{
							gchar* _tmp78_;
							gchar* _tmp79_;
							gchar* _tmp80_;
							gchar* _tmp81_;
							_tmp78_ = tarot_player_to_string_alloc (myself);
							_tmp79_ = _tmp78_;
							_tmp80_ = g_strdup_printf (_ ("%s slams!"), _tmp79_);
							_tmp81_ = _tmp80_;
							_g_free0 (_tmp79_);
							result = _tmp81_;
							bids = (g_free (bids), NULL);
							return result;
						}
						case TAROT_TAKE:
						{
							gchar* _tmp82_;
							gchar* _tmp83_;
							gchar* _tmp84_;
							gchar* _tmp85_;
							_tmp82_ = tarot_player_to_string_alloc (myself);
							_tmp83_ = _tmp82_;
							_tmp84_ = g_strdup_printf (_ ("%s slams (take)!"), _tmp83_);
							_tmp85_ = _tmp84_;
							_g_free0 (_tmp83_);
							result = _tmp85_;
							bids = (g_free (bids), NULL);
							return result;
						}
						case TAROT_PUSH:
						{
							gchar* _tmp86_;
							gchar* _tmp87_;
							gchar* _tmp88_;
							gchar* _tmp89_;
							_tmp86_ = tarot_player_to_string_alloc (myself);
							_tmp87_ = _tmp86_;
							_tmp88_ = g_strdup_printf (_ ("%s slams (push)!"), _tmp87_);
							_tmp89_ = _tmp88_;
							_g_free0 (_tmp87_);
							result = _tmp89_;
							bids = (g_free (bids), NULL);
							return result;
						}
						case TAROT_STRAIGHT_KEEP:
						{
							gchar* _tmp90_;
							gchar* _tmp91_;
							gchar* _tmp92_;
							gchar* _tmp93_;
							_tmp90_ = tarot_player_to_string_alloc (myself);
							_tmp91_ = _tmp90_;
							_tmp92_ = g_strdup_printf (_ ("%s slams (str. keep)!"), _tmp91_);
							_tmp93_ = _tmp92_;
							_g_free0 (_tmp91_);
							result = _tmp93_;
							bids = (g_free (bids), NULL);
							return result;
						}
						case TAROT_DOUBLE_KEEP:
						{
							gchar* _tmp94_;
							gchar* _tmp95_;
							gchar* _tmp96_;
							gchar* _tmp97_;
							_tmp94_ = tarot_player_to_string_alloc (myself);
							_tmp95_ = _tmp94_;
							_tmp96_ = g_strdup_printf (_ ("%s slams (dbl. keep)!"), _tmp95_);
							_tmp97_ = _tmp96_;
							_g_free0 (_tmp95_);
							result = _tmp97_;
							bids = (g_free (bids), NULL);
							return result;
						}
						default:
						break;
					}
				} else {
					TarotBid* _tmp98_;
					gint _tmp98__length1;
					TarotBid _tmp99_;
					_tmp98_ = bids;
					_tmp98__length1 = bids_length1;
					_tmp99_ = _tmp98_[myself];
					switch (_tmp99_) {
						case TAROT_TAKE:
						{
							gchar* _tmp100_;
							gchar* _tmp101_;
							gchar* _tmp102_;
							gchar* _tmp103_;
							_tmp100_ = tarot_player_to_string_alloc (myself);
							_tmp101_ = _tmp100_;
							_tmp102_ = g_strdup_printf (_ ("%s (take)"), _tmp101_);
							_tmp103_ = _tmp102_;
							_g_free0 (_tmp101_);
							result = _tmp103_;
							bids = (g_free (bids), NULL);
							return result;
						}
						case TAROT_PUSH:
						{
							gchar* _tmp104_;
							gchar* _tmp105_;
							gchar* _tmp106_;
							gchar* _tmp107_;
							_tmp104_ = tarot_player_to_string_alloc (myself);
							_tmp105_ = _tmp104_;
							_tmp106_ = g_strdup_printf (_ ("%s (push)"), _tmp105_);
							_tmp107_ = _tmp106_;
							_g_free0 (_tmp105_);
							result = _tmp107_;
							bids = (g_free (bids), NULL);
							return result;
						}
						case TAROT_STRAIGHT_KEEP:
						{
							gchar* _tmp108_;
							gchar* _tmp109_;
							gchar* _tmp110_;
							gchar* _tmp111_;
							_tmp108_ = tarot_player_to_string_alloc (myself);
							_tmp109_ = _tmp108_;
							_tmp110_ = g_strdup_printf (_ ("%s (str. keep)"), _tmp109_);
							_tmp111_ = _tmp110_;
							_g_free0 (_tmp109_);
							result = _tmp111_;
							bids = (g_free (bids), NULL);
							return result;
						}
						case TAROT_DOUBLE_KEEP:
						{
							gchar* _tmp112_;
							gchar* _tmp113_;
							gchar* _tmp114_;
							gchar* _tmp115_;
							_tmp112_ = tarot_player_to_string_alloc (myself);
							_tmp113_ = _tmp112_;
							_tmp114_ = g_strdup_printf (_ ("%s (dbl. keep)"), _tmp113_);
							_tmp115_ = _tmp114_;
							_g_free0 (_tmp113_);
							result = _tmp115_;
							bids = (g_free (bids), NULL);
							return result;
						}
						default:
						break;
					}
				}
			}
		}
	}
	_tmp116_ = tarot_player_to_string_alloc (myself);
	_tmp117_ = _tmp116_;
	_tmp118_ = g_strdup_printf (_ ("%s"), _tmp117_);
	_tmp119_ = _tmp118_;
	_g_free0 (_tmp117_);
	result = _tmp119_;
	bids = (g_free (bids), NULL);
	return result;
}

static void
tarot_widget_update_header_model (TarotWidget* self)
{
	gsize n_players = 0UL;
	TarotGame* _tmp0_;
	GType* types = NULL;
	GType* _tmp1_;
	gint types_length1;
	gint _types_size_;
	GtkListStore* model = NULL;
	GType* _tmp5_;
	gint _tmp5__length1;
	GtkListStore* _tmp6_;
	GtkTreeIter iter = {0};
	TarotPlayer myself = 0U;
	TarotGame* _tmp7_;
	TarotPlayer _tmp8_ = 0U;
	TarotGameError _tmp9_;
	TarotBid* bids = NULL;
	gint bids_length1 = 0;
	gint _bids_size_ = 0;
	TarotGame* _tmp10_;
	TarotBid* _tmp11_ = NULL;
	gsize _tmp12_ = 0;
	TarotGameError _tmp13_;
	TarotPlayer declarant = 0U;
	gboolean _tmp32_ = FALSE;
	TarotGame* _tmp33_;
	TarotPlayer _tmp34_ = 0U;
	TarotGameError _tmp35_;
	gint* scores = NULL;
	gint scores_length1 = 0;
	gint _scores_size_ = 0;
	TarotGame* _tmp42_;
	gint* _tmp43_ = NULL;
	gsize _tmp44_ = 0;
	TarotGameError _tmp45_;
	GtkTreeView* _tmp64_;
	GtkListStore* _tmp65_;
	GList* columns = NULL;
	GtkTreeView* _tmp66_;
	GList* _tmp67_;
	GList* _tmp68_;
	TarotPlayer taker = 0U;
	TarotGame* _tmp71_;
	TarotPlayer _tmp72_ = 0U;
	TarotPlayer partner = 0U;
	gboolean has_partner = FALSE;
	TarotGame* _tmp73_;
	TarotPlayer _tmp74_ = 0U;
	TarotGameError _tmp75_;
	GtkTreeView* _tmp94_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->current_game;
	n_players = tarot_game_n_players (_tmp0_);
	_tmp1_ = g_new0 (GType, n_players - 1);
	types = _tmp1_;
	types_length1 = n_players - 1;
	_types_size_ = types_length1;
	{
		gsize i = 0UL;
		i = (gsize) 1;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				GType* _tmp4_;
				gint _tmp4__length1;
				if (!_tmp2_) {
					gsize _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				if (!(i < n_players)) {
					break;
				}
				_tmp4_ = types;
				_tmp4__length1 = types_length1;
				_tmp4_[i - 1] = G_TYPE_STRING;
			}
		}
	}
	_tmp5_ = types;
	_tmp5__length1 = types_length1;
	_tmp6_ = gtk_list_store_newv (_tmp5__length1, _tmp5_);
	model = _tmp6_;
	_tmp7_ = self->priv->current_game;
	_tmp9_ = tarot_game_get_main_player (_tmp7_, &_tmp8_);
	myself = _tmp8_;
	if (_tmp9_ != TAROT_GAME_OK) {
		myself = (TarotPlayer) 0;
	}
	_tmp10_ = self->priv->current_game;
	_tmp13_ = tarot_game_get_bids_alloc (_tmp10_, &_tmp12_, &_tmp11_);
	bids = (g_free (bids), NULL);
	bids = _tmp11_;
	bids_length1 = _tmp12_;
	_bids_size_ = bids_length1;
	if (_tmp13_ == TAROT_GAME_OK) {
		GtkListStore* _tmp14_;
		GtkTreeIter _tmp15_ = {0};
		_tmp14_ = model;
		gtk_list_store_append (_tmp14_, &_tmp15_);
		iter = _tmp15_;
		{
			gsize i = 0UL;
			i = (gsize) 1;
			{
				gboolean _tmp16_ = FALSE;
				_tmp16_ = TRUE;
				while (TRUE) {
					TarotPlayer p = 0U;
					TarotBid* _tmp18_;
					gint _tmp18__length1;
					if (!_tmp16_) {
						gsize _tmp17_;
						_tmp17_ = i;
						i = _tmp17_ + 1;
					}
					_tmp16_ = FALSE;
					if (!(i < n_players)) {
						break;
					}
					p = (TarotPlayer) ((myself + i) % n_players);
					_tmp18_ = bids;
					_tmp18__length1 = bids_length1;
					if (p < ((TarotPlayer) _tmp18__length1)) {
						TarotBid* _tmp19_;
						gint _tmp19__length1;
						TarotBid _tmp20_;
						_tmp19_ = bids;
						_tmp19__length1 = bids_length1;
						_tmp20_ = _tmp19_[p];
						switch (_tmp20_) {
							case TAROT_PASS:
							{
								TarotBid* _tmp21_;
								gint _tmp21__length1;
								_tmp21_ = bids;
								_tmp21__length1 = bids_length1;
								if (((gsize) _tmp21__length1) < n_players) {
									GtkListStore* _tmp22_;
									GtkTreeIter _tmp23_;
									_tmp22_ = model;
									_tmp23_ = iter;
									gtk_list_store_set (_tmp22_, &_tmp23_, i - 1, _ ("pass"), -1);
								}
								break;
							}
							case TAROT_TAKE:
							{
								GtkListStore* _tmp24_;
								GtkTreeIter _tmp25_;
								_tmp24_ = model;
								_tmp25_ = iter;
								gtk_list_store_set (_tmp24_, &_tmp25_, i - 1, _ ("take"), -1);
								break;
							}
							case TAROT_PUSH:
							{
								GtkListStore* _tmp26_;
								GtkTreeIter _tmp27_;
								_tmp26_ = model;
								_tmp27_ = iter;
								gtk_list_store_set (_tmp26_, &_tmp27_, i - 1, _ ("push"), -1);
								break;
							}
							case TAROT_STRAIGHT_KEEP:
							{
								GtkListStore* _tmp28_;
								GtkTreeIter _tmp29_;
								_tmp28_ = model;
								_tmp29_ = iter;
								gtk_list_store_set (_tmp28_, &_tmp29_, i - 1, _ ("straight keep"), -1);
								break;
							}
							case TAROT_DOUBLE_KEEP:
							{
								GtkListStore* _tmp30_;
								GtkTreeIter _tmp31_;
								_tmp30_ = model;
								_tmp31_ = iter;
								gtk_list_store_set (_tmp30_, &_tmp31_, i - 1, _ ("double keep"), -1);
								break;
							}
							default:
							break;
						}
					}
				}
			}
		}
	}
	_tmp33_ = self->priv->current_game;
	_tmp35_ = tarot_game_get_declarant (_tmp33_, &_tmp34_);
	declarant = _tmp34_;
	if (_tmp35_ == TAROT_GAME_OK) {
		_tmp32_ = declarant != myself;
	} else {
		_tmp32_ = FALSE;
	}
	if (_tmp32_) {
		GtkListStore* _tmp36_;
		GtkTreeIter _tmp37_ = {0};
		_tmp36_ = model;
		gtk_list_store_append (_tmp36_, &_tmp37_);
		iter = _tmp37_;
		{
			gsize i = 0UL;
			i = (gsize) 1;
			{
				gboolean _tmp38_ = FALSE;
				_tmp38_ = TRUE;
				while (TRUE) {
					TarotPlayer p = 0U;
					if (!_tmp38_) {
						gsize _tmp39_;
						_tmp39_ = i;
						i = _tmp39_ + 1;
					}
					_tmp38_ = FALSE;
					if (!(i < n_players)) {
						break;
					}
					p = (TarotPlayer) ((myself + i) % n_players);
					if (p == declarant) {
						GtkListStore* _tmp40_;
						GtkTreeIter _tmp41_;
						_tmp40_ = model;
						_tmp41_ = iter;
						gtk_list_store_set (_tmp40_, &_tmp41_, i - 1, _ ("slam"), -1);
					}
				}
			}
		}
	}
	_tmp42_ = self->priv->current_game;
	_tmp45_ = tarot_game_get_scores_alloc (_tmp42_, &_tmp44_, &_tmp43_);
	scores = (g_free (scores), NULL);
	scores = _tmp43_;
	scores_length1 = _tmp44_;
	_scores_size_ = scores_length1;
	if (_tmp45_ == TAROT_GAME_OK) {
		GtkListStore* _tmp46_;
		GtkTreeIter _tmp47_ = {0};
		_tmp46_ = model;
		gtk_list_store_append (_tmp46_, &_tmp47_);
		iter = _tmp47_;
		{
			gsize i = 0UL;
			i = (gsize) 1;
			{
				gboolean _tmp48_ = FALSE;
				_tmp48_ = TRUE;
				while (TRUE) {
					TarotPlayer p = 0U;
					gint* _tmp50_;
					gint _tmp50__length1;
					gint _tmp51_;
					if (!_tmp48_) {
						gsize _tmp49_;
						_tmp49_ = i;
						i = _tmp49_ + 1;
					}
					_tmp48_ = FALSE;
					if (!(i < n_players)) {
						break;
					}
					p = (TarotPlayer) ((myself + i) % n_players);
					_tmp50_ = scores;
					_tmp50__length1 = scores_length1;
					_tmp51_ = _tmp50_[p];
					if ((_tmp51_ % 2) == 0) {
						GtkListStore* _tmp52_;
						GtkTreeIter _tmp53_;
						gint* _tmp54_;
						gint _tmp54__length1;
						gint _tmp55_;
						gchar* _tmp56_;
						gchar* _tmp57_;
						_tmp52_ = model;
						_tmp53_ = iter;
						_tmp54_ = scores;
						_tmp54__length1 = scores_length1;
						_tmp55_ = _tmp54_[p];
						_tmp56_ = g_strdup_printf ("%i", _tmp55_ / 2);
						_tmp57_ = _tmp56_;
						gtk_list_store_set (_tmp52_, &_tmp53_, i - 1, _tmp57_, -1);
						_g_free0 (_tmp57_);
					} else {
						GtkListStore* _tmp58_;
						GtkTreeIter _tmp59_;
						gint* _tmp60_;
						gint _tmp60__length1;
						gint _tmp61_;
						gchar* _tmp62_;
						gchar* _tmp63_;
						_tmp58_ = model;
						_tmp59_ = iter;
						_tmp60_ = scores;
						_tmp60__length1 = scores_length1;
						_tmp61_ = _tmp60_[p];
						_tmp62_ = g_strdup_printf ("%d.5", _tmp61_ / 2);
						_tmp63_ = _tmp62_;
						gtk_list_store_set (_tmp58_, &_tmp59_, i - 1, _tmp63_, -1);
						_g_free0 (_tmp63_);
					}
				}
			}
		}
	}
	_tmp64_ = self->priv->player_information_others;
	_tmp65_ = model;
	gtk_tree_view_set_model (_tmp64_, (GtkTreeModel*) _tmp65_);
	_tmp66_ = self->priv->player_information_others;
	_tmp67_ = gtk_tree_view_get_columns (_tmp66_);
	columns = _tmp67_;
	_tmp68_ = columns;
	{
		GList* c_collection = NULL;
		GList* c_it = NULL;
		c_collection = _tmp68_;
		for (c_it = c_collection; c_it != NULL; c_it = c_it->next) {
			GtkTreeViewColumn* c = NULL;
			c = (GtkTreeViewColumn*) c_it->data;
			{
				GtkTreeView* _tmp69_;
				GtkTreeViewColumn* _tmp70_;
				_tmp69_ = self->priv->player_information_others;
				_tmp70_ = c;
				gtk_tree_view_remove_column (_tmp69_, _tmp70_);
			}
		}
	}
	_tmp71_ = self->priv->current_game;
	tarot_game_get_taker (_tmp71_, &_tmp72_);
	taker = _tmp72_;
	_tmp73_ = self->priv->current_game;
	_tmp75_ = tarot_game_get_partner (_tmp73_, &_tmp74_);
	partner = _tmp74_;
	has_partner = _tmp75_ == TAROT_GAME_OK;
	{
		gsize i = 0UL;
		i = (gsize) 0;
		{
			gboolean _tmp76_ = FALSE;
			_tmp76_ = TRUE;
			while (TRUE) {
				TarotPlayer p = 0U;
				GtkCellRendererText* renderer = NULL;
				GtkCellRendererText* _tmp78_;
				GtkCellRendererText* _tmp84_;
				GtkTreeViewColumn* column = NULL;
				gchar* _tmp85_;
				gchar* _tmp86_;
				GtkCellRendererText* _tmp87_;
				GtkTreeViewColumn* _tmp88_;
				GtkTreeViewColumn* _tmp89_;
				GtkTreeViewColumn* _tmp90_;
				GtkTreeViewColumn* _tmp91_;
				GtkTreeView* _tmp92_;
				GtkTreeViewColumn* _tmp93_;
				if (!_tmp76_) {
					gsize _tmp77_;
					_tmp77_ = i;
					i = _tmp77_ + 1;
				}
				_tmp76_ = FALSE;
				if (!((i + 1) < n_players)) {
					break;
				}
				p = (TarotPlayer) (((myself + i) + 1) % n_players);
				_tmp78_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
				g_object_ref_sink (_tmp78_);
				renderer = _tmp78_;
				if (taker == p) {
					GtkCellRendererText* _tmp79_;
					GtkCellRendererText* _tmp80_;
					_tmp79_ = renderer;
					g_object_set (_tmp79_, "background", "#a40000", NULL);
					_tmp80_ = renderer;
					g_object_set (_tmp80_, "foreground", "#eeeeec", NULL);
				} else {
					gboolean _tmp81_ = FALSE;
					if (has_partner) {
						_tmp81_ = partner == p;
					} else {
						_tmp81_ = FALSE;
					}
					if (_tmp81_) {
						GtkCellRendererText* _tmp82_;
						GtkCellRendererText* _tmp83_;
						_tmp82_ = renderer;
						g_object_set (_tmp82_, "background", "#c4a000", NULL);
						_tmp83_ = renderer;
						g_object_set (_tmp83_, "foreground", "#2e3436", NULL);
					}
				}
				_tmp84_ = renderer;
				g_object_set (_tmp84_, "alignment", PANGO_ALIGN_CENTER, NULL);
				_tmp85_ = tarot_player_to_string_alloc (p);
				_tmp86_ = _tmp85_;
				_tmp87_ = renderer;
				_tmp88_ = gtk_tree_view_column_new_with_attributes (_tmp86_, (GtkCellRenderer*) _tmp87_, "text", i, NULL, NULL);
				g_object_ref_sink (_tmp88_);
				_tmp89_ = _tmp88_;
				_g_free0 (_tmp86_);
				column = _tmp89_;
				_tmp90_ = column;
				gtk_tree_view_column_set_expand (_tmp90_, TRUE);
				_tmp91_ = column;
				gtk_tree_view_column_set_alignment (_tmp91_, (gfloat) 0.5);
				_tmp92_ = self->priv->player_information_others;
				_tmp93_ = column;
				gtk_tree_view_append_column (_tmp92_, _tmp93_);
				_g_object_unref0 (column);
				_g_object_unref0 (renderer);
			}
		}
	}
	_tmp94_ = self->priv->player_information_others;
	gtk_widget_show ((GtkWidget*) _tmp94_);
	(columns == NULL) ? NULL : (columns = (g_list_free (columns), NULL));
	scores = (g_free (scores), NULL);
	bids = (g_free (bids), NULL);
	_g_object_unref0 (model);
	types = (g_free (types), NULL);
}

static TarotCard*
tarot_widget_trick_content_aux (TarotWidget* self,
                                TarotPlayer view,
                                TarotPlayer* trick_taker,
                                gsize trick,
                                gint* result_length1)
{
	TarotPlayer _vala_trick_taker = 0U;
	gsize n_players = 0UL;
	TarotGame* _tmp0_;
	TarotCard* cards_trick = NULL;
	TarotCard* _tmp1_;
	gint cards_trick_length1;
	gint _cards_trick_size_;
	TarotGameCardAnalysis* trick_content = NULL;
	TarotGameCardAnalysis* _tmp2_;
	gint trick_content_length1;
	gint _trick_content_size_;
	TarotPlayer trick_leader = 0U;
	gboolean has_trick_content = FALSE;
	TarotGame* _tmp3_;
	TarotGameCardAnalysis* _tmp4_ = NULL;
	gsize _tmp5_ = 0;
	TarotGameError _tmp6_;
	gboolean has_trick_leader = FALSE;
	TarotGame* _tmp7_;
	TarotPlayer _tmp8_ = 0U;
	TarotGameError _tmp9_;
	TarotGame* _tmp10_;
	TarotPlayer _tmp11_ = 0U;
	gboolean _tmp12_ = FALSE;
	TarotCard* result;
	g_return_val_if_fail (self != NULL, NULL);
	_vala_trick_taker = (TarotPlayer) 42;
	_tmp0_ = self->priv->current_game;
	n_players = tarot_game_n_players (_tmp0_);
	_tmp1_ = g_new0 (TarotCard, n_players);
	cards_trick = _tmp1_;
	cards_trick_length1 = n_players;
	_cards_trick_size_ = cards_trick_length1;
	_tmp2_ = g_new0 (TarotGameCardAnalysis, 0);
	trick_content = _tmp2_;
	trick_content_length1 = 0;
	_trick_content_size_ = trick_content_length1;
	_tmp3_ = self->priv->current_game;
	_tmp6_ = tarot_game_get_trick_cards_alloc (_tmp3_, trick, &_tmp5_, &_tmp4_);
	trick_content = (g_free (trick_content), NULL);
	trick_content = _tmp4_;
	trick_content_length1 = _tmp5_;
	_trick_content_size_ = trick_content_length1;
	has_trick_content = _tmp6_ == TAROT_GAME_OK;
	_tmp7_ = self->priv->current_game;
	_tmp9_ = tarot_game_get_trick_leader (_tmp7_, trick, &_tmp8_);
	trick_leader = _tmp8_;
	has_trick_leader = _tmp9_ == TAROT_GAME_OK;
	_tmp10_ = self->priv->current_game;
	tarot_game_get_trick_taker (_tmp10_, trick, &_tmp11_);
	_vala_trick_taker = _tmp11_;
	if (has_trick_content) {
		_tmp12_ = has_trick_leader;
	} else {
		_tmp12_ = FALSE;
	}
	if (_tmp12_) {
		TarotCard* card_of = NULL;
		TarotCard* _tmp16_;
		gint card_of_length1;
		gint _card_of_size_;
		TarotGameCardAnalysis* _tmp20_;
		gint _tmp20__length1;
		TarotCard* _tmp32_;
		gint _tmp32__length1;
		{
			gsize i = 0UL;
			i = (gsize) 0;
			{
				gboolean _tmp13_ = FALSE;
				_tmp13_ = TRUE;
				while (TRUE) {
					TarotCard* _tmp15_;
					gint _tmp15__length1;
					if (!_tmp13_) {
						gsize _tmp14_;
						_tmp14_ = i;
						i = _tmp14_ + 1;
					}
					_tmp13_ = FALSE;
					if (!(i < n_players)) {
						break;
					}
					_tmp15_ = cards_trick;
					_tmp15__length1 = cards_trick_length1;
					_tmp15_[i] = (TarotCard) 79;
				}
			}
		}
		_tmp16_ = g_new0 (TarotCard, n_players);
		card_of = _tmp16_;
		card_of_length1 = n_players;
		_card_of_size_ = card_of_length1;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp17_ = FALSE;
				_tmp17_ = TRUE;
				while (TRUE) {
					TarotCard* _tmp19_;
					gint _tmp19__length1;
					if (!_tmp17_) {
						gint _tmp18_;
						_tmp18_ = i;
						i = _tmp18_ + 1;
					}
					_tmp17_ = FALSE;
					if (!(((gsize) i) < n_players)) {
						break;
					}
					_tmp19_ = card_of;
					_tmp19__length1 = card_of_length1;
					_tmp19_[i] = (TarotCard) 79;
				}
			}
		}
		_tmp20_ = trick_content;
		_tmp20__length1 = trick_content_length1;
		_vala_assert (((gsize) _tmp20__length1) <= n_players, "trick_content.length <= n_players");
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp21_ = FALSE;
				_tmp21_ = TRUE;
				while (TRUE) {
					TarotGameCardAnalysis* _tmp23_;
					gint _tmp23__length1;
					gsize p = 0UL;
					TarotCard* _tmp24_;
					gint _tmp24__length1;
					TarotGameCardAnalysis* _tmp25_;
					gint _tmp25__length1;
					TarotGameCardAnalysis _tmp26_;
					if (!_tmp21_) {
						gint _tmp22_;
						_tmp22_ = i;
						i = _tmp22_ + 1;
					}
					_tmp21_ = FALSE;
					_tmp23_ = trick_content;
					_tmp23__length1 = trick_content_length1;
					if (!(i < _tmp23__length1)) {
						break;
					}
					p = (trick_leader + i) % n_players;
					_tmp24_ = card_of;
					_tmp24__length1 = card_of_length1;
					_tmp25_ = trick_content;
					_tmp25__length1 = trick_content_length1;
					_tmp26_ = _tmp25_[i];
					_tmp24_[p] = _tmp26_.card;
				}
			}
		}
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp27_ = FALSE;
				_tmp27_ = TRUE;
				while (TRUE) {
					TarotPlayer p = 0U;
					TarotCard* _tmp29_;
					gint _tmp29__length1;
					TarotCard* _tmp30_;
					gint _tmp30__length1;
					TarotCard _tmp31_;
					if (!_tmp27_) {
						gint _tmp28_;
						_tmp28_ = i;
						i = _tmp28_ + 1;
					}
					_tmp27_ = FALSE;
					if (!(((gsize) i) < n_players)) {
						break;
					}
					p = (TarotPlayer) (((gsize) (view + i)) % n_players);
					_tmp29_ = cards_trick;
					_tmp29__length1 = cards_trick_length1;
					_tmp30_ = card_of;
					_tmp30__length1 = card_of_length1;
					_tmp31_ = _tmp30_[p];
					_tmp29_[i] = _tmp31_;
				}
			}
		}
		_tmp32_ = cards_trick;
		_tmp32__length1 = cards_trick_length1;
		if (result_length1) {
			*result_length1 = _tmp32__length1;
		}
		result = _tmp32_;
		card_of = (g_free (card_of), NULL);
		trick_content = (g_free (trick_content), NULL);
		if (trick_taker) {
			*trick_taker = _vala_trick_taker;
		}
		return result;
	} else {
		TarotCard* _tmp33_;
		TarotCard* _tmp34_;
		gint _tmp34__length1;
		_tmp33_ = g_new0 (TarotCard, 0);
		_tmp34_ = _tmp33_;
		_tmp34__length1 = 0;
		if (result_length1) {
			*result_length1 = _tmp34__length1;
		}
		result = _tmp34_;
		trick_content = (g_free (trick_content), NULL);
		cards_trick = (g_free (cards_trick), NULL);
		if (trick_taker) {
			*trick_taker = _vala_trick_taker;
		}
		return result;
	}
}

static TarotCard*
tarot_widget_trick_content (TarotWidget* self,
                            TarotPlayer view,
                            TarotPlayer* trick_taker,
                            gint* result_length1)
{
	TarotPlayer _vala_trick_taker = 0U;
	gsize current_trick = 0UL;
	gboolean has_current_trick = FALSE;
	TarotGame* _tmp0_;
	gsize _tmp1_ = 0UL;
	TarotGameError _tmp2_;
	gboolean _tmp3_ = FALSE;
	TarotGameCardAnalysis* trick_content = NULL;
	TarotGameCardAnalysis* _tmp7_;
	gint trick_content_length1;
	gint _trick_content_size_;
	gboolean _tmp8_ = FALSE;
	gboolean has_trick_content = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	TarotPlayer my_trick_taker = 0U;
	TarotCard* ret = NULL;
	TarotPlayer _tmp17_ = 0U;
	gint _tmp18_ = 0;
	TarotCard* _tmp19_;
	gint ret_length1;
	gint _ret_size_;
	TarotCard* _tmp20_;
	gint _tmp20__length1;
	TarotCard* result;
	g_return_val_if_fail (self != NULL, NULL);
	_vala_trick_taker = (TarotPlayer) 42;
	_tmp0_ = self->priv->current_game;
	_tmp2_ = tarot_game_get_current_trick (_tmp0_, &_tmp1_);
	current_trick = _tmp1_;
	has_current_trick = _tmp2_ == TAROT_GAME_OK;
	if (has_current_trick) {
		TarotGame* _tmp4_;
		_tmp4_ = self->priv->current_game;
		_tmp3_ = current_trick >= tarot_game_n_tricks (_tmp4_);
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		gsize _tmp5_;
		_tmp5_ = current_trick;
		current_trick = _tmp5_ - 1;
	}
	if (!has_current_trick) {
		TarotGame* _tmp6_;
		_tmp6_ = self->priv->current_game;
		current_trick = tarot_game_n_tricks (_tmp6_) - 1;
		has_current_trick = TRUE;
	}
	_tmp7_ = g_new0 (TarotGameCardAnalysis, 0);
	trick_content = _tmp7_;
	trick_content_length1 = 0;
	_trick_content_size_ = trick_content_length1;
	if (has_current_trick) {
		TarotGame* _tmp9_;
		TarotGameCardAnalysis* _tmp10_ = NULL;
		gsize _tmp11_ = 0;
		TarotGameError _tmp12_;
		_tmp9_ = self->priv->current_game;
		_tmp12_ = tarot_game_get_trick_cards_alloc (_tmp9_, current_trick, &_tmp11_, &_tmp10_);
		trick_content = (g_free (trick_content), NULL);
		trick_content = _tmp10_;
		trick_content_length1 = _tmp11_;
		_trick_content_size_ = trick_content_length1;
		_tmp8_ = _tmp12_ == TAROT_GAME_OK;
	} else {
		_tmp8_ = FALSE;
	}
	has_trick_content = _tmp8_;
	if (has_trick_content) {
		_tmp14_ = current_trick > ((gsize) 0);
	} else {
		_tmp14_ = FALSE;
	}
	if (_tmp14_) {
		TarotGameCardAnalysis* _tmp15_;
		gint _tmp15__length1;
		_tmp15_ = trick_content;
		_tmp15__length1 = trick_content_length1;
		_tmp13_ = _tmp15__length1 == 0;
	} else {
		_tmp13_ = FALSE;
	}
	if (_tmp13_) {
		gsize _tmp16_;
		_tmp16_ = current_trick;
		current_trick = _tmp16_ - 1;
	}
	_tmp19_ = tarot_widget_trick_content_aux (self, view, &_tmp17_, current_trick, &_tmp18_);
	my_trick_taker = _tmp17_;
	ret = _tmp19_;
	ret_length1 = _tmp18_;
	_ret_size_ = ret_length1;
	_vala_trick_taker = my_trick_taker;
	_tmp20_ = ret;
	_tmp20__length1 = ret_length1;
	if (result_length1) {
		*result_length1 = _tmp20__length1;
	}
	result = _tmp20_;
	trick_content = (g_free (trick_content), NULL);
	if (trick_taker) {
		*trick_taker = _vala_trick_taker;
	}
	return result;
}

static TarotCard*
tarot_widget_center_content (TarotWidget* self,
                             gint* result_length1)
{
	TarotCard* foreground = NULL;
	TarotCard* _tmp0_;
	gint foreground_length1;
	gint _foreground_size_;
	TarotGame* _tmp1_;
	TarotCard* _tmp23_;
	gint _tmp23__length1;
	TarotCard* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_new0 (TarotCard, 0);
	foreground = _tmp0_;
	foreground_length1 = 0;
	_foreground_size_ = foreground_length1;
	_tmp1_ = self->priv->current_game;
	if (tarot_game_step (_tmp1_) == TAROT_DISCARD) {
		TarotGame* _tmp2_;
		TarotCard* _tmp3_ = NULL;
		gsize _tmp4_ = 0;
		TarotGameError _tmp5_;
		_tmp2_ = self->priv->current_game;
		_tmp5_ = tarot_game_get_dog_alloc (_tmp2_, &_tmp4_, &_tmp3_);
		foreground = (g_free (foreground), NULL);
		foreground = _tmp3_;
		foreground_length1 = _tmp4_;
		_foreground_size_ = foreground_length1;
		if (_tmp5_ != TAROT_GAME_OK) {
			_vala_assert (FALSE, "false");
		}
	} else {
		gsize i_trick = 0UL;
		TarotGameCardAnalysis* trick_cards = NULL;
		TarotGameCardAnalysis* _tmp6_;
		gint trick_cards_length1;
		gint _trick_cards_size_;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_ = FALSE;
		TarotGame* _tmp11_;
		gsize _tmp12_ = 0UL;
		TarotGameError _tmp13_;
		_tmp6_ = g_new0 (TarotGameCardAnalysis, 0);
		trick_cards = _tmp6_;
		trick_cards_length1 = 0;
		_trick_cards_size_ = trick_cards_length1;
		_tmp11_ = self->priv->current_game;
		_tmp13_ = tarot_game_get_current_trick (_tmp11_, &_tmp12_);
		i_trick = _tmp12_;
		if (_tmp13_ == TAROT_GAME_OK) {
			_tmp10_ = i_trick == ((gsize) 0);
		} else {
			_tmp10_ = FALSE;
		}
		if (_tmp10_) {
			TarotGame* _tmp14_;
			TarotGameCardAnalysis* _tmp15_ = NULL;
			gsize _tmp16_ = 0;
			TarotGameError _tmp17_;
			_tmp14_ = self->priv->current_game;
			_tmp17_ = tarot_game_get_trick_cards_alloc (_tmp14_, i_trick, &_tmp16_, &_tmp15_);
			trick_cards = (g_free (trick_cards), NULL);
			trick_cards = _tmp15_;
			trick_cards_length1 = _tmp16_;
			_trick_cards_size_ = trick_cards_length1;
			_tmp9_ = _tmp17_ == TAROT_GAME_OK;
		} else {
			_tmp9_ = FALSE;
		}
		if (_tmp9_) {
			TarotGameCardAnalysis* _tmp18_;
			gint _tmp18__length1;
			_tmp18_ = trick_cards;
			_tmp18__length1 = trick_cards_length1;
			_tmp8_ = _tmp18__length1 == 0;
		} else {
			_tmp8_ = FALSE;
		}
		if (_tmp8_) {
			TarotGame* _tmp19_;
			TarotCard* _tmp20_ = NULL;
			gsize _tmp21_ = 0;
			TarotGameError _tmp22_;
			_tmp19_ = self->priv->current_game;
			_tmp22_ = tarot_game_get_public_discard_alloc (_tmp19_, &_tmp21_, &_tmp20_);
			foreground = (g_free (foreground), NULL);
			foreground = _tmp20_;
			foreground_length1 = _tmp21_;
			_foreground_size_ = foreground_length1;
			_tmp7_ = _tmp22_ == TAROT_GAME_OK;
		} else {
			_tmp7_ = FALSE;
		}
		if (_tmp7_) {
		}
		trick_cards = (g_free (trick_cards), NULL);
	}
	_tmp23_ = foreground;
	_tmp23__length1 = foreground_length1;
	if (result_length1) {
		*result_length1 = _tmp23__length1;
	}
	result = _tmp23_;
	return result;
}

static void
_vala_array_add6 (TarotCard* * array,
                  gint* length,
                  gint* size,
                  TarotCard value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (TarotCard, *array, *size);
	}
	(*array)[(*length)++] = value;
}

static void
tarot_widget_update (TarotWidget* self)
{
	TarotPlayer myself = 0U;
	TarotGame* _tmp0_;
	TarotPlayer _tmp1_ = 0U;
	TarotGameError _tmp2_;
	TarotCard* my_cards = NULL;
	gint my_cards_length1 = 0;
	gint _my_cards_size_ = 0;
	TarotGame* _tmp3_;
	TarotCard* _tmp4_ = NULL;
	gsize _tmp5_ = 0;
	TarotGameError _tmp6_;
	TarotPlayer taker = 0U;
	TarotCard* dog = NULL;
	TarotCard* _tmp8_;
	gint dog_length1;
	gint _dog_size_;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	TarotGame* _tmp12_;
	TarotFanCardView* _tmp28_;
	TarotCard* _tmp29_;
	gint _tmp29__length1;
	TarotPlayer trick_taker = 0U;
	TarotTrickCardView* _tmp30_;
	TarotPlayer _tmp31_ = 0U;
	gint _tmp32_ = 0;
	TarotCard* _tmp33_;
	TarotCard* _tmp34_;
	gint _tmp34__length1;
	gsize position = 0UL;
	TarotGame* _tmp35_;
	TarotGame* _tmp36_;
	gsize* trick_selection = NULL;
	gsize* _tmp37_;
	gint trick_selection_length1;
	gint _trick_selection_size_;
	TarotTrickCardView* _tmp38_;
	gint _tmp39_ = 0;
	TarotCard* _tmp40_;
	TarotCard* _tmp41_;
	gint _tmp41__length1;
	gboolean _tmp42_;
	TarotCenterCardView* _tmp48_;
	gint _tmp49_ = 0;
	TarotCard* _tmp50_;
	TarotCard* _tmp51_;
	gint _tmp51__length1;
	TarotCenterCardView* _tmp52_;
	gint _tmp53_ = 0;
	TarotCard* _tmp54_;
	TarotCard* _tmp55_;
	gint _tmp55__length1;
	gboolean _tmp56_;
	TarotGame* _tmp59_;
	TarotPlayer _tmp60_ = 0U;
	gchar* taker_format = NULL;
	gchar* _tmp61_;
	TarotBid* bids = NULL;
	gint bids_length1 = 0;
	gint _bids_size_ = 0;
	TarotGame* _tmp62_;
	TarotBid* _tmp63_ = NULL;
	gsize _tmp64_ = 0;
	TarotGameError _tmp65_;
	TarotBid* _tmp67_;
	gint _tmp67__length1;
	GtkLabel* _tmp74_;
	gchar* _tmp75_;
	gchar* _tmp76_;
	TarotCard call = 0U;
	TarotPlayer partner = 0U;
	static const gchar* names[79] = {N_ ("A♥"), N_ ("2♥"), N_ ("3♥"), N_ ("4♥"), N_ ("5♥"), N_ ("6♥"), N_ ("7♥"), N_ ("8♥"), N_ ("9♥"), N_ ("10♥"), N_ ("J♥"), N_ ("C♥"), N_ ("Q♥"), N_ ("K♥"), N_ ("A♣"), N_ ("2♣"), N_ ("3♣"), N_ ("4♣"), N_ ("5♣"), N_ ("6♣"), N_ ("7♣"), N_ ("8♣"), N_ ("9♣"), N_ ("10♣"), N_ ("J♣"), N_ ("C♣"), N_ ("Q♣"), N_ ("K♣"), N_ ("A♦"), N_ ("2♦"), N_ ("3♦"), N_ ("4♦"), N_ ("5♦"), N_ ("6♦"), N_ ("7♦"), N_ ("8♦"), N_ ("9♦"), N_ ("10♦"), N_ ("J♦"), N_ ("C♦"), N_ ("Q♦"), N_ ("K♦"), N_ ("A♠"), N_ ("2♠"), N_ ("3♠"), N_ ("4♠"), N_ ("5♠"), N_ ("6♠"), N_ ("7♠"), N_ ("8♠"), N_ ("9♠"), N_ ("10♠"), N_ ("J♠"), N_ ("C♠"), N_ ("Q♠"), N_ ("K♠"), N_ ("1★"), N_ ("2★"), N_ ("3★"), N_ ("4★"), N_ ("5★"), N_ ("6★"), N_ ("7★"), N_ ("8★"), N_ ("9★"), N_ ("10★"), N_ ("11★"), N_ ("12★"), N_ ("13★"), N_ ("14★"), N_ ("15★"), N_ ("16★"), N_ ("17★"), N_ ("18★"), N_ ("19★"), N_ ("20★"), N_ ("21★"), N_ ("EXC"), NULL};
	gboolean _tmp77_ = FALSE;
	TarotGame* _tmp78_;
	TarotCard _tmp79_ = 0U;
	TarotGameError _tmp80_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->current_game;
	_tmp2_ = tarot_game_get_main_player (_tmp0_, &_tmp1_);
	myself = _tmp1_;
	if (_tmp2_ != TAROT_GAME_OK) {
		myself = (TarotPlayer) 0;
	}
	_tmp3_ = self->priv->current_game;
	_tmp6_ = tarot_game_get_cards_alloc (_tmp3_, myself, &_tmp5_, &_tmp4_);
	my_cards = (g_free (my_cards), NULL);
	my_cards = _tmp4_;
	my_cards_length1 = _tmp5_;
	_my_cards_size_ = my_cards_length1;
	if (_tmp6_ != TAROT_GAME_OK) {
		TarotCard* _tmp7_;
		_tmp7_ = g_new0 (TarotCard, 0);
		my_cards = (g_free (my_cards), NULL);
		my_cards = _tmp7_;
		my_cards_length1 = 0;
		_my_cards_size_ = my_cards_length1;
	}
	taker = (TarotPlayer) 42;
	_tmp8_ = g_new0 (TarotCard, 0);
	dog = _tmp8_;
	dog_length1 = 0;
	_dog_size_ = dog_length1;
	_tmp12_ = self->priv->current_game;
	if (tarot_game_step (_tmp12_) == TAROT_DISCARD) {
		TarotGame* _tmp13_;
		TarotPlayer _tmp14_ = 0U;
		TarotGameError _tmp15_;
		_tmp13_ = self->priv->current_game;
		_tmp15_ = tarot_game_get_taker (_tmp13_, &_tmp14_);
		taker = _tmp14_;
		_tmp11_ = _tmp15_ == TAROT_GAME_OK;
	} else {
		_tmp11_ = FALSE;
	}
	if (_tmp11_) {
		_tmp10_ = taker == myself;
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		TarotGame* _tmp16_;
		TarotCard* _tmp17_ = NULL;
		gsize _tmp18_ = 0;
		TarotGameError _tmp19_;
		_tmp16_ = self->priv->current_game;
		_tmp19_ = tarot_game_get_dog_alloc (_tmp16_, &_tmp18_, &_tmp17_);
		dog = (g_free (dog), NULL);
		dog = _tmp17_;
		dog_length1 = _tmp18_;
		_dog_size_ = dog_length1;
		_tmp9_ = _tmp19_ == TAROT_GAME_OK;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		gboolean present[78] = {0};
		TarotCard* _tmp22_;
		gint _tmp22__length1;
		TarotCard* _tmp23_;
		gint _tmp23__length1;
		TarotCard* _tmp24_;
		{
			TarotCard i = 0U;
			i = (TarotCard) 0;
			{
				gboolean _tmp20_ = FALSE;
				_tmp20_ = TRUE;
				while (TRUE) {
					if (!_tmp20_) {
						TarotCard _tmp21_;
						_tmp21_ = i;
						i = _tmp21_ + 1;
					}
					_tmp20_ = FALSE;
					if (!(i < ((TarotCard) 78))) {
						break;
					}
					present[i] = FALSE;
				}
			}
		}
		_tmp22_ = my_cards;
		_tmp22__length1 = my_cards_length1;
		{
			TarotCard* c_collection = NULL;
			gint c_collection_length1 = 0;
			gint _c_collection_size_ = 0;
			gint c_it = 0;
			c_collection = _tmp22_;
			c_collection_length1 = _tmp22__length1;
			for (c_it = 0; c_it < c_collection_length1; c_it = c_it + 1) {
				TarotCard c = 0U;
				c = c_collection[c_it];
				{
					present[c] = TRUE;
				}
			}
		}
		_tmp23_ = dog;
		_tmp23__length1 = dog_length1;
		{
			TarotCard* c_collection = NULL;
			gint c_collection_length1 = 0;
			gint _c_collection_size_ = 0;
			gint c_it = 0;
			c_collection = _tmp23_;
			c_collection_length1 = _tmp23__length1;
			for (c_it = 0; c_it < c_collection_length1; c_it = c_it + 1) {
				TarotCard c = 0U;
				c = c_collection[c_it];
				{
					present[c] = TRUE;
				}
			}
		}
		_tmp24_ = g_new0 (TarotCard, 0);
		my_cards = (g_free (my_cards), NULL);
		my_cards = _tmp24_;
		my_cards_length1 = 0;
		_my_cards_size_ = my_cards_length1;
		{
			TarotCard i = 0U;
			i = (TarotCard) 0;
			{
				gboolean _tmp25_ = FALSE;
				_tmp25_ = TRUE;
				while (TRUE) {
					gboolean _tmp27_;
					if (!_tmp25_) {
						TarotCard _tmp26_;
						_tmp26_ = i;
						i = _tmp26_ + 1;
					}
					_tmp25_ = FALSE;
					if (!(i < ((TarotCard) 78))) {
						break;
					}
					_tmp27_ = present[i];
					if (_tmp27_) {
						_vala_array_add6 (&my_cards, &my_cards_length1, &_my_cards_size_, i);
					}
				}
			}
		}
	}
	_tmp28_ = self->priv->hand_widget;
	_tmp29_ = my_cards;
	_tmp29__length1 = my_cards_length1;
	tarot_card_view_set_cards ((TarotCardView*) _tmp28_, _tmp29_, (gint) _tmp29__length1);
	_tmp30_ = self->priv->trick_widget;
	_tmp33_ = tarot_widget_trick_content (self, myself, &_tmp31_, &_tmp32_);
	trick_taker = _tmp31_;
	_tmp34_ = _tmp33_;
	_tmp34__length1 = _tmp32_;
	tarot_card_view_set_cards ((TarotCardView*) _tmp30_, _tmp34_, (gint) _tmp32_);
	_tmp34_ = (g_free (_tmp34_), NULL);
	_tmp35_ = self->priv->current_game;
	_tmp36_ = self->priv->current_game;
	position = ((trick_taker + tarot_game_n_players (_tmp35_)) - myself) % tarot_game_n_players (_tmp36_);
	_tmp37_ = g_new0 (gsize, 1);
	_tmp37_[0] = position;
	trick_selection = _tmp37_;
	trick_selection_length1 = 1;
	_trick_selection_size_ = trick_selection_length1;
	_tmp38_ = self->priv->trick_widget;
	_tmp40_ = tarot_card_view_get_cards ((TarotCardView*) _tmp38_, &_tmp39_);
	_tmp41_ = _tmp40_;
	_tmp41__length1 = _tmp39_;
	_tmp42_ = position < ((gsize) _tmp39_);
	_tmp41_ = (g_free (_tmp41_), NULL);
	if (_tmp42_) {
		TarotTrickCardView* _tmp43_;
		gsize* _tmp44_;
		gint _tmp44__length1;
		_tmp43_ = self->priv->trick_widget;
		_tmp44_ = trick_selection;
		_tmp44__length1 = trick_selection_length1;
		tarot_card_view_set_selection ((TarotCardView*) _tmp43_, _tmp44_, (gint) _tmp44__length1);
	} else {
		TarotTrickCardView* _tmp45_;
		gsize* _tmp46_;
		gsize* _tmp47_;
		gint _tmp47__length1;
		_tmp45_ = self->priv->trick_widget;
		_tmp46_ = g_new0 (gsize, 0);
		_tmp47_ = _tmp46_;
		_tmp47__length1 = 0;
		tarot_card_view_set_selection ((TarotCardView*) _tmp45_, _tmp47_, (gint) 0);
		_tmp47_ = (g_free (_tmp47_), NULL);
	}
	_tmp48_ = self->priv->center_widget;
	_tmp50_ = tarot_widget_center_content (self, &_tmp49_);
	_tmp51_ = _tmp50_;
	_tmp51__length1 = _tmp49_;
	tarot_card_view_set_cards ((TarotCardView*) _tmp48_, _tmp51_, (gint) _tmp49_);
	_tmp51_ = (g_free (_tmp51_), NULL);
	_tmp52_ = self->priv->center_widget;
	_tmp54_ = tarot_card_view_get_cards ((TarotCardView*) _tmp52_, &_tmp53_);
	_tmp55_ = _tmp54_;
	_tmp55__length1 = _tmp53_;
	_tmp56_ = _tmp53_ == 0;
	_tmp55_ = (g_free (_tmp55_), NULL);
	if (_tmp56_) {
		TarotCenterCardView* _tmp57_;
		_tmp57_ = self->priv->center_widget;
		gtk_widget_hide ((GtkWidget*) _tmp57_);
	} else {
		TarotCenterCardView* _tmp58_;
		_tmp58_ = self->priv->center_widget;
		gtk_widget_show ((GtkWidget*) _tmp58_);
	}
	_tmp59_ = self->priv->current_game;
	tarot_game_get_taker (_tmp59_, &_tmp60_);
	taker = _tmp60_;
	_tmp61_ = g_strdup ("%s");
	taker_format = _tmp61_;
	_tmp62_ = self->priv->current_game;
	_tmp65_ = tarot_game_get_bids_alloc (_tmp62_, &_tmp64_, &_tmp63_);
	bids = (g_free (bids), NULL);
	bids = _tmp63_;
	bids_length1 = _tmp64_;
	_bids_size_ = bids_length1;
	if (_tmp65_ != TAROT_GAME_OK) {
		TarotBid* _tmp66_;
		_tmp66_ = g_new0 (TarotBid, 0);
		bids = (g_free (bids), NULL);
		bids = _tmp66_;
		bids_length1 = 0;
		_bids_size_ = bids_length1;
	}
	_tmp67_ = bids;
	_tmp67__length1 = bids_length1;
	if (taker < ((TarotPlayer) _tmp67__length1)) {
		TarotBid* _tmp68_;
		gint _tmp68__length1;
		TarotBid _tmp69_;
		_tmp68_ = bids;
		_tmp68__length1 = bids_length1;
		_tmp69_ = _tmp68_[taker];
		switch (_tmp69_) {
			case TAROT_PASS:
			{
				break;
			}
			case TAROT_TAKE:
			{
				gchar* _tmp70_;
				_tmp70_ = g_strdup (_ ("%s\ntakes"));
				_g_free0 (taker_format);
				taker_format = _tmp70_;
				break;
			}
			case TAROT_PUSH:
			{
				gchar* _tmp71_;
				_tmp71_ = g_strdup (_ ("%s\npushes"));
				_g_free0 (taker_format);
				taker_format = _tmp71_;
				break;
			}
			case TAROT_STRAIGHT_KEEP:
			{
				gchar* _tmp72_;
				_tmp72_ = g_strdup (_ ("%s\nkeeps"));
				_g_free0 (taker_format);
				taker_format = _tmp72_;
				break;
			}
			case TAROT_DOUBLE_KEEP:
			{
				gchar* _tmp73_;
				_tmp73_ = g_strdup (_ ("%s\nkeeps (double)"));
				_g_free0 (taker_format);
				taker_format = _tmp73_;
				break;
			}
			default:
			break;
		}
	}
	_tmp74_ = self->priv->player_information_myself;
	_tmp75_ = tarot_widget_compute_my_status_with_score (self);
	_tmp76_ = _tmp75_;
	gtk_label_set_label (_tmp74_, _tmp76_);
	_g_free0 (_tmp76_);
	tarot_widget_update_header_model (self);
	_tmp78_ = self->priv->current_game;
	_tmp80_ = tarot_game_get_call (_tmp78_, &_tmp79_);
	call = _tmp79_;
	if (_tmp80_ == TAROT_GAME_OK) {
		TarotGame* _tmp81_;
		TarotPlayer _tmp82_ = 0U;
		TarotGameError _tmp83_;
		_tmp81_ = self->priv->current_game;
		_tmp83_ = tarot_game_get_partner (_tmp81_, &_tmp82_);
		partner = _tmp82_;
		_tmp77_ = _tmp83_ != TAROT_GAME_OK;
	} else {
		_tmp77_ = FALSE;
	}
	if (_tmp77_) {
		GtkLabel* _tmp84_;
		const gchar* _tmp85_;
		gchar* _tmp86_;
		gchar* _tmp87_;
		GtkLabel* _tmp88_;
		_tmp84_ = self->priv->call_info;
		_tmp85_ = names[(gint) call];
		_tmp86_ = g_strdup_printf (_ ("Call: %s"), _ (_tmp85_));
		_tmp87_ = _tmp86_;
		gtk_label_set_label (_tmp84_, _tmp87_);
		_g_free0 (_tmp87_);
		_tmp88_ = self->priv->call_info;
		gtk_widget_show ((GtkWidget*) _tmp88_);
	} else {
		gboolean _tmp89_ = FALSE;
		TarotGame* _tmp90_;
		TarotPlayer _tmp91_ = 0U;
		TarotGameError _tmp92_;
		_tmp90_ = self->priv->current_game;
		_tmp92_ = tarot_game_get_partner (_tmp90_, &_tmp91_);
		partner = _tmp91_;
		if (_tmp92_ == TAROT_GAME_OK) {
			_tmp89_ = partner == myself;
		} else {
			_tmp89_ = FALSE;
		}
		if (_tmp89_) {
			GtkLabel* _tmp93_;
			const gchar* _tmp94_;
			gchar* _tmp95_;
			gchar* _tmp96_;
			GtkLabel* _tmp97_;
			_tmp93_ = self->priv->call_info;
			_tmp94_ = names[(gint) call];
			_tmp95_ = g_strdup_printf (_ ("Call: you (%s)"), _ (_tmp94_));
			_tmp96_ = _tmp95_;
			gtk_label_set_label (_tmp93_, _tmp96_);
			_g_free0 (_tmp96_);
			_tmp97_ = self->priv->call_info;
			gtk_widget_show ((GtkWidget*) _tmp97_);
		} else {
			GtkLabel* _tmp98_;
			_tmp98_ = self->priv->call_info;
			gtk_widget_hide ((GtkWidget*) _tmp98_);
		}
	}
	bids = (g_free (bids), NULL);
	_g_free0 (taker_format);
	trick_selection = (g_free (trick_selection), NULL);
	dog = (g_free (dog), NULL);
	my_cards = (g_free (my_cards), NULL);
}

static void
tarot_widget_card_selected (TarotWidget* self,
                            gsize i_card)
{
	TarotCard c = 0U;
	TarotFanCardView* _tmp0_;
	gint _tmp1_ = 0;
	TarotCard* _tmp2_;
	TarotCard* _tmp3_;
	gint _tmp3__length1;
	TarotCard _tmp4_;
	TarotCard _tmp5_;
	TarotGameEvent* e = NULL;
	TarotGameEvent* _tmp6_;
	TarotGame* _tmp7_;
	TarotGameEvent* _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->hand_widget;
	_tmp2_ = tarot_card_view_get_cards ((TarotCardView*) _tmp0_, &_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _tmp1_;
	_tmp4_ = _tmp3_[i_card];
	_tmp5_ = _tmp4_;
	_tmp3_ = (g_free (_tmp3_), NULL);
	c = _tmp5_;
	_tmp6_ = tarot_game_event_alloc_card (c);
	e = _tmp6_;
	_tmp7_ = self->priv->current_game;
	_tmp8_ = e;
	if (tarot_game_check_event (_tmp7_, _tmp8_)) {
		g_signal_emit (self, tarot_widget_signals[TAROT_WIDGET_SELECT_CARD_SIGNAL], 0, (guint) c);
	} else {
		tarot_widget_no_card_selected (self);
	}
	__vala_TarotGameEvent_free0 (e);
}

static void
tarot_widget_no_card_selected (TarotWidget* self)
{
	gsize* selection = NULL;
	gsize* _tmp0_;
	gint selection_length1;
	gint _selection_size_;
	TarotFanCardView* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_new0 (gsize, 0);
	selection = _tmp0_;
	selection_length1 = 0;
	_selection_size_ = selection_length1;
	_tmp1_ = self->priv->hand_widget;
	tarot_card_view_set_selection ((TarotCardView*) _tmp1_, selection, (gint) selection_length1);
	selection = (g_free (selection), NULL);
}

TarotWidget*
tarot_widget_construct (GType object_type)
{
	TarotWidget * self = NULL;
	self = (TarotWidget*) g_object_new (object_type, NULL);
	return self;
}

TarotWidget*
tarot_widget_new (void)
{
	return tarot_widget_construct (TAROT_TYPE_WIDGET);
}

TarotGame*
tarot_widget_get_game (TarotWidget* self)
{
	TarotGame* result;
	TarotGame* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->current_game;
	result = _tmp0_;
	return result;
}

static TarotGame*
_vala_TarotGame_copy (TarotGame* self)
{
	return g_boxed_copy (tarot_game_get_type (), self);
}

static gpointer
__vala_TarotGame_copy0 (gpointer self)
{
	return self ? _vala_TarotGame_copy (self) : NULL;
}

void
tarot_widget_set_game (TarotWidget* self,
                       TarotGame* value)
{
	TarotGame* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = __vala_TarotGame_copy0 (value);
	__vala_TarotGame_free0 (self->priv->current_game);
	self->priv->current_game = _tmp0_;
	tarot_widget_update (self);
	g_object_notify_by_pspec ((GObject *) self, tarot_widget_properties[TAROT_WIDGET_GAME_PROPERTY]);
}

static void
g_cclosure_user_marshal_VOID__POINTER_INT (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__POINTER_INT) (gpointer data1, gpointer arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__POINTER_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__POINTER_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_pointer (param_values + 1), g_value_get_int (param_values + 2), data2);
}

static gboolean
_tarot_widget___lambda21_ (TarotWidget* self,
                           GdkEventMotion* motion,
                           gsize i_card)
{
	TarotFanCardView* _tmp0_;
	g_return_val_if_fail (motion != NULL, FALSE);
	_tmp0_ = self->priv->hand_widget;
	tarot_card_view_set_pointed ((TarotCardView*) _tmp0_, &i_card);
}

static gboolean
__tarot_widget___lambda21__tarot_card_view_motion_notify_event_card (TarotCardView* _sender,
                                                                     GdkEventMotion* motion,
                                                                     gsize index,
                                                                     gpointer self)
{
	gboolean result;
	result = _tarot_widget___lambda21_ ((TarotWidget*) self, motion, index);
	return result;
}

static gboolean
_tarot_widget___lambda22_ (TarotWidget* self,
                           GdkEventMotion* motion)
{
	TarotFanCardView* _tmp0_;
	g_return_val_if_fail (motion != NULL, FALSE);
	_tmp0_ = self->priv->hand_widget;
	tarot_card_view_set_pointed ((TarotCardView*) _tmp0_, NULL);
}

static gboolean
__tarot_widget___lambda22__tarot_card_view_motion_notify_event_no_card (TarotCardView* _sender,
                                                                        GdkEventMotion* motion,
                                                                        gpointer self)
{
	gboolean result;
	result = _tarot_widget___lambda22_ ((TarotWidget*) self, motion);
	return result;
}

static gboolean
_tarot_widget___lambda23_ (TarotWidget* self,
                           GdkEventMotion* motion,
                           gsize i_card)
{
	TarotTrickCardView* _tmp0_;
	g_return_val_if_fail (motion != NULL, FALSE);
	_tmp0_ = self->priv->trick_widget;
	tarot_card_view_set_pointed ((TarotCardView*) _tmp0_, &i_card);
}

static gboolean
__tarot_widget___lambda23__tarot_card_view_motion_notify_event_card (TarotCardView* _sender,
                                                                     GdkEventMotion* motion,
                                                                     gsize index,
                                                                     gpointer self)
{
	gboolean result;
	result = _tarot_widget___lambda23_ ((TarotWidget*) self, motion, index);
	return result;
}

static gboolean
_tarot_widget___lambda24_ (TarotWidget* self,
                           GdkEventMotion* motion)
{
	TarotTrickCardView* _tmp0_;
	g_return_val_if_fail (motion != NULL, FALSE);
	_tmp0_ = self->priv->trick_widget;
	tarot_card_view_set_pointed ((TarotCardView*) _tmp0_, NULL);
}

static gboolean
__tarot_widget___lambda24__tarot_card_view_motion_notify_event_no_card (TarotCardView* _sender,
                                                                        GdkEventMotion* motion,
                                                                        gpointer self)
{
	gboolean result;
	result = _tarot_widget___lambda24_ ((TarotWidget*) self, motion);
	return result;
}

static gboolean
_tarot_widget___lambda25_ (TarotWidget* self,
                           GdkEventMotion* motion,
                           gsize i_card)
{
	TarotCenterCardView* _tmp0_;
	g_return_val_if_fail (motion != NULL, FALSE);
	_tmp0_ = self->priv->center_widget;
	tarot_card_view_set_pointed ((TarotCardView*) _tmp0_, &i_card);
}

static gboolean
__tarot_widget___lambda25__tarot_card_view_motion_notify_event_card (TarotCardView* _sender,
                                                                     GdkEventMotion* motion,
                                                                     gsize index,
                                                                     gpointer self)
{
	gboolean result;
	result = _tarot_widget___lambda25_ ((TarotWidget*) self, motion, index);
	return result;
}

static gboolean
_tarot_widget___lambda26_ (TarotWidget* self,
                           GdkEventMotion* motion)
{
	TarotCenterCardView* _tmp0_;
	g_return_val_if_fail (motion != NULL, FALSE);
	_tmp0_ = self->priv->center_widget;
	tarot_card_view_set_pointed ((TarotCardView*) _tmp0_, NULL);
}

static gboolean
__tarot_widget___lambda26__tarot_card_view_motion_notify_event_no_card (TarotCardView* _sender,
                                                                        GdkEventMotion* motion,
                                                                        gpointer self)
{
	gboolean result;
	result = _tarot_widget___lambda26_ ((TarotWidget*) self, motion);
	return result;
}

static gboolean
_tarot_widget___lambda27_ (TarotWidget* self,
                           GdkEventButton* button,
                           gsize i_card)
{
	g_return_val_if_fail (button != NULL, FALSE);
	if (self->priv->allow_play) {
		FILE* _tmp0_;
		_tmp0_ = stderr;
		fprintf (_tmp0_, "allow_play = true\n");
		tarot_widget_card_selected (self, i_card);
	}
}

static gboolean
__tarot_widget___lambda27__tarot_card_view_button_press_event_card (TarotCardView* _sender,
                                                                    GdkEventButton* button,
                                                                    gsize index,
                                                                    gpointer self)
{
	gboolean result;
	result = _tarot_widget___lambda27_ ((TarotWidget*) self, button, index);
	return result;
}

static gboolean
_tarot_widget___lambda28_ (TarotWidget* self,
                           GdkEventButton* button)
{
	g_return_val_if_fail (button != NULL, FALSE);
	tarot_widget_no_card_selected (self);
}

static gboolean
__tarot_widget___lambda28__tarot_card_view_button_press_event_no_card (TarotCardView* _sender,
                                                                       GdkEventButton* button,
                                                                       gpointer self)
{
	gboolean result;
	result = _tarot_widget___lambda28_ ((TarotWidget*) self, button);
	return result;
}

static void
_tarot_widget___lambda29_ (TarotWidget* self,
                           gint n)
{
	if (n == 0) {
		GtkButton* _tmp0_;
		_tmp0_ = self->priv->button_discard;
		gtk_button_set_label (_tmp0_, _ ("Discard"));
	} else {
		if (n < 0) {
			GtkButton* _tmp1_;
			gchar* _tmp2_;
			gchar* _tmp3_;
			_tmp1_ = self->priv->button_discard;
			_tmp2_ = g_strdup_printf (_ ("%d cards in excess"), -n);
			_tmp3_ = _tmp2_;
			gtk_button_set_label (_tmp1_, _tmp3_);
			_g_free0 (_tmp3_);
		} else {
			GtkButton* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			_tmp4_ = self->priv->button_discard;
			_tmp5_ = g_strdup_printf (_ ("%d..."), n);
			_tmp6_ = _tmp5_;
			gtk_button_set_label (_tmp4_, _tmp6_);
			_g_free0 (_tmp6_);
		}
	}
}

static void
__tarot_widget___lambda29__tarot_card_selection_n_remaining_cards_to_select (TarotCardSelection* _sender,
                                                                             gint n,
                                                                             gpointer self)
{
	_tarot_widget___lambda29_ ((TarotWidget*) self, n);
}

static GObject *
tarot_widget_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TarotWidget * self;
	TarotFanCardView* _tmp0_;
	TarotFanCardView* _tmp1_;
	TarotTrickCardView* _tmp2_;
	TarotTrickCardView* _tmp3_;
	TarotCenterCardView* _tmp4_;
	TarotCenterCardView* _tmp5_;
	TarotFanCardView* _tmp6_;
	TarotFanCardView* _tmp7_;
	TarotCardSelection* _tmp8_;
	GtkFlowBox* _tmp9_;
	GtkBox* _tmp10_;
	GtkBox* _tmp11_;
	GtkBox* _tmp12_;
	GtkBox* _tmp13_;
	GtkStack* _tmp14_;
	parent_class = G_OBJECT_CLASS (tarot_widget_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TAROT_TYPE_WIDGET, TarotWidget);
	_tmp0_ = self->priv->hand_widget;
	g_signal_connect_object ((TarotCardView*) _tmp0_, "motion-notify-event-card", (GCallback) __tarot_widget___lambda21__tarot_card_view_motion_notify_event_card, self, 0);
	_tmp1_ = self->priv->hand_widget;
	g_signal_connect_object ((TarotCardView*) _tmp1_, "motion-notify-event-no-card", (GCallback) __tarot_widget___lambda22__tarot_card_view_motion_notify_event_no_card, self, 0);
	_tmp2_ = self->priv->trick_widget;
	g_signal_connect_object ((TarotCardView*) _tmp2_, "motion-notify-event-card", (GCallback) __tarot_widget___lambda23__tarot_card_view_motion_notify_event_card, self, 0);
	_tmp3_ = self->priv->trick_widget;
	g_signal_connect_object ((TarotCardView*) _tmp3_, "motion-notify-event-no-card", (GCallback) __tarot_widget___lambda24__tarot_card_view_motion_notify_event_no_card, self, 0);
	_tmp4_ = self->priv->center_widget;
	g_signal_connect_object ((TarotCardView*) _tmp4_, "motion-notify-event-card", (GCallback) __tarot_widget___lambda25__tarot_card_view_motion_notify_event_card, self, 0);
	_tmp5_ = self->priv->center_widget;
	g_signal_connect_object ((TarotCardView*) _tmp5_, "motion-notify-event-no-card", (GCallback) __tarot_widget___lambda26__tarot_card_view_motion_notify_event_no_card, self, 0);
	_tmp6_ = self->priv->hand_widget;
	g_signal_connect_object ((TarotCardView*) _tmp6_, "button-press-event-card", (GCallback) __tarot_widget___lambda27__tarot_card_view_button_press_event_card, self, 0);
	_tmp7_ = self->priv->hand_widget;
	g_signal_connect_object ((TarotCardView*) _tmp7_, "button-press-event-no-card", (GCallback) __tarot_widget___lambda28__tarot_card_view_button_press_event_no_card, self, 0);
	_tmp8_ = self->priv->discard_selection;
	g_signal_connect_object (_tmp8_, "n-remaining-cards-to-select", (GCallback) __tarot_widget___lambda29__tarot_card_selection_n_remaining_cards_to_select, self, 0);
	_tmp9_ = self->priv->widget_bid;
	gtk_widget_show ((GtkWidget*) _tmp9_);
	_tmp10_ = self->priv->widget_decl;
	gtk_widget_show ((GtkWidget*) _tmp10_);
	_tmp11_ = self->priv->widget_call;
	gtk_widget_show ((GtkWidget*) _tmp11_);
	_tmp12_ = self->priv->widget_discard;
	gtk_widget_show ((GtkWidget*) _tmp12_);
	_tmp13_ = self->priv->widget_handful;
	gtk_widget_show ((GtkWidget*) _tmp13_);
	_tmp14_ = self->priv->entry_stack;
	gtk_widget_hide ((GtkWidget*) _tmp14_);
	return obj;
}

static void
tarot_widget_class_init (TarotWidgetClass * klass,
                         gpointer klass_data)
{
	tarot_widget_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TarotWidget_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_tarot_widget_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_tarot_widget_set_property;
	G_OBJECT_CLASS (klass)->constructor = tarot_widget_constructor;
	G_OBJECT_CLASS (klass)->finalize = tarot_widget_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAROT_WIDGET_GAME_PROPERTY, tarot_widget_properties[TAROT_WIDGET_GAME_PROPERTY] = g_param_spec_boxed ("game", "game", "game", tarot_game_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/eu/planete_kraus/Tarot/widget.ui");
	tarot_widget_signals[TAROT_WIDGET_SELECT_BID_SIGNAL] = g_signal_new ("select-bid", TAROT_TYPE_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, tarot_bid_get_type ());
	tarot_widget_signals[TAROT_WIDGET_SELECT_DECLARATION_SIGNAL] = g_signal_new ("select-declaration", TAROT_TYPE_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	tarot_widget_signals[TAROT_WIDGET_SELECT_CALL_SIGNAL] = g_signal_new ("select-call", TAROT_TYPE_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
	tarot_widget_signals[TAROT_WIDGET_SELECT_DISCARD_SIGNAL] = g_signal_new ("select-discard", TAROT_TYPE_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__POINTER_INT, G_TYPE_NONE, 2, G_TYPE_POINTER, G_TYPE_INT);
	tarot_widget_signals[TAROT_WIDGET_SELECT_HANDFUL_SIGNAL] = g_signal_new ("select-handful", TAROT_TYPE_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__POINTER_INT, G_TYPE_NONE, 2, G_TYPE_POINTER, G_TYPE_INT);
	tarot_widget_signals[TAROT_WIDGET_SELECT_CARD_SIGNAL] = g_signal_new ("select-card", TAROT_TYPE_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "trick_widget", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, trick_widget));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "center_widget", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, center_widget));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "hand_widget", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, hand_widget));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "entry_stack", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, entry_stack));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "widget_bid", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, widget_bid));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "button_take", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, button_take));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "button_push", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, button_push));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "button_straight_keep", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, button_straight_keep));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "button_double_keep", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, button_double_keep));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "player_information_myself", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, player_information_myself));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "widget_decl", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, widget_decl));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "button_slam", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, button_slam));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "widget_call", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, widget_call));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "call_selection", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, call_selection));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "button_call", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, button_call));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "widget_discard", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, widget_discard));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "discard_selection", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, discard_selection));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "button_discard", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, button_discard));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "widget_handful", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, widget_handful));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "handful_selection", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, handful_selection));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "button_handful", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, button_handful));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "player_information_others", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, player_information_others));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "call_info", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, call_info));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "select_pass", G_CALLBACK(_tarot_widget_select_pass_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "select_take", G_CALLBACK(_tarot_widget_select_take_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "select_push", G_CALLBACK(_tarot_widget_select_push_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "select_straight_keep", G_CALLBACK(_tarot_widget_select_straight_keep_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "select_double_keep", G_CALLBACK(_tarot_widget_select_double_keep_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "select_none", G_CALLBACK(_tarot_widget_select_none_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "select_slam", G_CALLBACK(_tarot_widget_select_slam_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "button_call_clicked", G_CALLBACK(_tarot_widget_button_call_clicked_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "valid_call_selection", G_CALLBACK(_tarot_widget_valid_call_selection_tarot_card_selection_valid_selection));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "invalid_call_selection", G_CALLBACK(_tarot_widget_invalid_call_selection_tarot_card_selection_invalid_selection));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "button_discard_clicked", G_CALLBACK(_tarot_widget_button_discard_clicked_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "valid_discard_selection", G_CALLBACK(_tarot_widget_valid_discard_selection_tarot_card_selection_valid_selection));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "invalid_discard_selection", G_CALLBACK(_tarot_widget_invalid_discard_selection_tarot_card_selection_invalid_selection));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "button_handful_clicked", G_CALLBACK(_tarot_widget_button_handful_clicked_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "valid_handful_selection", G_CALLBACK(_tarot_widget_valid_handful_selection_tarot_card_selection_valid_selection));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "invalid_handful_selection", G_CALLBACK(_tarot_widget_invalid_handful_selection_tarot_card_selection_invalid_selection));
}

static void
tarot_widget_instance_init (TarotWidget * self,
                            gpointer klass)
{
	TarotGame* _tmp0_;
	self->priv = tarot_widget_get_instance_private (self);
	self->priv->allow_play = TRUE;
	_tmp0_ = tarot_game_alloc ();
	self->priv->current_game = _tmp0_;
	g_type_ensure (TAROT_TYPE_TRICK_CARD_VIEW);
	g_type_ensure (TAROT_TYPE_CENTER_CARD_VIEW);
	g_type_ensure (TAROT_TYPE_FAN_CARD_VIEW);
	g_type_ensure (TAROT_TYPE_CARD_SELECTION);
	g_type_ensure (TAROT_TYPE_CARD_SELECTION);
	g_type_ensure (TAROT_TYPE_CARD_SELECTION);
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
tarot_widget_finalize (GObject * obj)
{
	TarotWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TAROT_TYPE_WIDGET, TarotWidget);
	__vala_TarotGame_free0 (self->priv->current_game);
	G_OBJECT_CLASS (tarot_widget_parent_class)->finalize (obj);
}

static GType
tarot_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TarotWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tarot_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TarotWidget), 0, (GInstanceInitFunc) tarot_widget_instance_init, NULL };
	GType tarot_widget_type_id;
	tarot_widget_type_id = g_type_register_static (gtk_box_get_type (), "TarotWidget", &g_define_type_info, 0);
	TarotWidget_private_offset = g_type_add_instance_private (tarot_widget_type_id, sizeof (TarotWidgetPrivate));
	return tarot_widget_type_id;
}

GType
tarot_widget_get_type (void)
{
	static volatile gsize tarot_widget_type_id__once = 0;
	if (g_once_init_enter (&tarot_widget_type_id__once)) {
		GType tarot_widget_type_id;
		tarot_widget_type_id = tarot_widget_get_type_once ();
		g_once_init_leave (&tarot_widget_type_id__once, tarot_widget_type_id);
	}
	return tarot_widget_type_id__once;
}

static void
_vala_tarot_widget_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	TarotWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TAROT_TYPE_WIDGET, TarotWidget);
	switch (property_id) {
		case TAROT_WIDGET_GAME_PROPERTY:
		g_value_set_boxed (value, tarot_widget_get_game (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_tarot_widget_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	TarotWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TAROT_TYPE_WIDGET, TarotWidget);
	switch (property_id) {
		case TAROT_WIDGET_GAME_PROPERTY:
		tarot_widget_set_game (self, g_value_get_boxed (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

